/* App.c generated by valac 0.56.17, the Vala compiler
 * generated from App.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*           2020 Martin Abente Lahaye
*           2021 Justin Haygood (jhaygood86@gmail.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "applications.h"
#include <flatpak.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gdesktopappinfo.h>
#include <glib/gi18n-lib.h>

#define PERMISSIONS_BACKEND_APP_GROUP "Context"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PERMISSIONS_BACKEND_APP_0_PROPERTY,
	PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY,
	PERMISSIONS_BACKEND_APP_ID_PROPERTY,
	PERMISSIONS_BACKEND_APP_NAME_PROPERTY,
	PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY,
	PERMISSIONS_BACKEND_APP_ICON_PROPERTY,
	PERMISSIONS_BACKEND_APP_NUM_PROPERTIES
};
static GParamSpec* permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

struct _PermissionsBackendAppPrivate {
	FlatpakInstalledRef* _installed_ref;
	gchar* _id;
	gchar* _name;
	gchar* _description;
	GIcon* _icon;
};

struct _Block5Data {
	int _ref_count_;
	PermissionsBackendApp* self;
	GPtrArray* permissions;
	GPtrArray* current_permissions;
};

static gint PermissionsBackendApp_private_offset;
static gpointer permissions_backend_app_parent_class = NULL;
static GHashTable* permissions_backend_app__permission_names;
static GHashTable* permissions_backend_app__permission_names = NULL;

static gchar* permissions_backend_app_get_overrides_path (PermissionsBackendApp* self);
static gboolean permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                           GPtrArray* overrides,
                                                           const gchar* permission);
static GPtrArray* permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                                GKeyFile* key_file);
static void _g_free0_ (gpointer var);
static void permissions_backend_app_set_id (PermissionsBackendApp* self,
                                     const gchar* value);
static void permissions_backend_app_set_name (PermissionsBackendApp* self,
                                       const gchar* value);
static void permissions_backend_app_set_description (PermissionsBackendApp* self,
                                              const gchar* value);
static void permissions_backend_app_set_icon (PermissionsBackendApp* self,
                                       GIcon* value);
static void permissions_backend_app_set_permission_names (GHashTable* value);
static GObject * permissions_backend_app_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static void _permissions_backend_app___lambda4_ (Block5Data* _data5_,
                                          const gchar* key);
static void __permissions_backend_app___lambda4__gh_func (gconstpointer key,
                                                   gconstpointer value,
                                                   gpointer self);
static void _permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void permissions_backend_app_finalize (GObject * obj);
static GType permissions_backend_app_get_type_once (void);
static void _vala_permissions_backend_app_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_permissions_backend_app_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
permissions_backend_app_get_instance_private (PermissionsBackendApp* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionsBackendApp_private_offset);
}

PermissionsBackendApp*
permissions_backend_app_construct (GType object_type,
                                   FlatpakInstalledRef* installed_ref)
{
	PermissionsBackendApp * self = NULL;
#line 36 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (installed_ref != NULL, NULL);
#line 37 "../src/Permissions/Backend/App.vala"
	self = (PermissionsBackendApp*) g_object_new (object_type, "installed-ref", installed_ref, NULL);
#line 36 "../src/Permissions/Backend/App.vala"
	return self;
#line 154 "App.c"
}

PermissionsBackendApp*
permissions_backend_app_new (FlatpakInstalledRef* installed_ref)
{
#line 36 "../src/Permissions/Backend/App.vala"
	return permissions_backend_app_construct (PERMISSIONS_BACKEND_TYPE_APP, installed_ref);
#line 162 "App.c"
}

static gchar*
permissions_backend_app_get_overrides_path (PermissionsBackendApp* self)
{
	gchar* overrides_folder_path = NULL;
	PermissionsBackendFlatpakManager* _tmp0_;
	PermissionsBackendFlatpakManager* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* overrides_folder = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 148 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp0_ = permissions_backend_flatpak_manager_get_default ();
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp1_ = _tmp0_;
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp2_ = permissions_backend_flatpak_manager_get_user_installation_path (_tmp1_);
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp3_, "overrides", NULL);
#line 149 "../src/Permissions/Backend/App.vala"
	_tmp5_ = _tmp4_;
#line 149 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (_tmp1_);
#line 149 "../src/Permissions/Backend/App.vala"
	overrides_folder_path = _tmp5_;
#line 155 "../src/Permissions/Backend/App.vala"
	_tmp6_ = overrides_folder_path;
#line 155 "../src/Permissions/Backend/App.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 155 "../src/Permissions/Backend/App.vala"
	overrides_folder = _tmp7_;
#line 156 "../src/Permissions/Backend/App.vala"
	_tmp8_ = overrides_folder;
#line 156 "../src/Permissions/Backend/App.vala"
	if (!g_file_query_exists (_tmp8_, NULL)) {
#line 212 "App.c"
		{
			GFile* _tmp9_;
#line 158 "../src/Permissions/Backend/App.vala"
			_tmp9_ = overrides_folder;
#line 158 "../src/Permissions/Backend/App.vala"
			g_file_make_directory (_tmp9_, NULL, &_inner_error0_);
#line 158 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "App.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 157 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 157 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 160 "../src/Permissions/Backend/App.vala"
			_tmp10_ = e;
#line 160 "../src/Permissions/Backend/App.vala"
			_tmp11_ = _tmp10_->message;
#line 160 "../src/Permissions/Backend/App.vala"
			g_critical ("App.vala:160: Couldn't create overrides folder: %s", _tmp11_);
#line 157 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 243 "App.c"
		}
		__finally0:
#line 157 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/Permissions/Backend/App.vala"
			_g_object_unref0 (overrides_folder);
#line 157 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_folder_path);
#line 157 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 157 "../src/Permissions/Backend/App.vala"
			return NULL;
#line 258 "App.c"
		}
	}
#line 164 "../src/Permissions/Backend/App.vala"
	_tmp12_ = overrides_folder_path;
#line 164 "../src/Permissions/Backend/App.vala"
	_tmp13_ = self->priv->_id;
#line 164 "../src/Permissions/Backend/App.vala"
	_tmp14_ = g_build_path (G_DIR_SEPARATOR_S, _tmp12_, _tmp13_, NULL);
#line 164 "../src/Permissions/Backend/App.vala"
	result = _tmp14_;
#line 164 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (overrides_folder);
#line 164 "../src/Permissions/Backend/App.vala"
	_g_free0 (overrides_folder_path);
#line 164 "../src/Permissions/Backend/App.vala"
	return result;
#line 275 "App.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 294 "App.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 316 "App.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 320 "App.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 326 "App.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 330 "App.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 334 "App.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 342 "App.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 370 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 379 "App.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 393 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 402 "App.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 416 "App.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 425 "App.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 434 "App.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 447 "App.c"
}

static gboolean
permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                  GPtrArray* overrides,
                                                  const gchar* permission)
{
	gchar* _tmp0_ = NULL;
	gchar* negated_permission = NULL;
	gchar* _tmp3_;
	gboolean result;
#line 171 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (overrides != NULL, FALSE);
#line 171 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (permission != NULL, FALSE);
#line 172 "../src/Permissions/Backend/App.vala"
	if (string_contains (permission, "=!")) {
#line 467 "App.c"
		gchar* _tmp1_;
#line 173 "../src/Permissions/Backend/App.vala"
		_tmp1_ = string_replace (permission, "=!", "=");
#line 173 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp0_);
#line 173 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _tmp1_;
#line 475 "App.c"
	} else {
		gchar* _tmp2_;
#line 174 "../src/Permissions/Backend/App.vala"
		_tmp2_ = string_replace (permission, "=", "=!");
#line 174 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp0_);
#line 174 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _tmp2_;
#line 484 "App.c"
	}
#line 172 "../src/Permissions/Backend/App.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 172 "../src/Permissions/Backend/App.vala"
	negated_permission = _tmp3_;
#line 490 "App.c"
	{
		gint i = 0;
#line 176 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 495 "App.c"
		{
			gboolean _tmp4_ = FALSE;
#line 176 "../src/Permissions/Backend/App.vala"
			_tmp4_ = TRUE;
#line 176 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 502 "App.c"
				gint _tmp6_;
				gint _tmp7_;
				gchar* o = NULL;
				gconstpointer _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 176 "../src/Permissions/Backend/App.vala"
				if (!_tmp4_) {
#line 512 "App.c"
					gint _tmp5_;
#line 176 "../src/Permissions/Backend/App.vala"
					_tmp5_ = i;
#line 176 "../src/Permissions/Backend/App.vala"
					i = _tmp5_ + 1;
#line 518 "App.c"
				}
#line 176 "../src/Permissions/Backend/App.vala"
				_tmp4_ = FALSE;
#line 176 "../src/Permissions/Backend/App.vala"
				_tmp6_ = vala_g_ptr_array_get_length (overrides);
#line 176 "../src/Permissions/Backend/App.vala"
				_tmp7_ = _tmp6_;
#line 176 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp7_)) {
#line 176 "../src/Permissions/Backend/App.vala"
					break;
#line 530 "App.c"
				}
#line 177 "../src/Permissions/Backend/App.vala"
				_tmp8_ = g_ptr_array_index (overrides, (guint) i);
#line 177 "../src/Permissions/Backend/App.vala"
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 177 "../src/Permissions/Backend/App.vala"
				o = _tmp9_;
#line 178 "../src/Permissions/Backend/App.vala"
				_tmp10_ = o;
#line 178 "../src/Permissions/Backend/App.vala"
				_tmp11_ = negated_permission;
#line 178 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 179 "../src/Permissions/Backend/App.vala"
					result = TRUE;
#line 179 "../src/Permissions/Backend/App.vala"
					_g_free0 (o);
#line 179 "../src/Permissions/Backend/App.vala"
					_g_free0 (negated_permission);
#line 179 "../src/Permissions/Backend/App.vala"
					_g_free0 (_tmp0_);
#line 179 "../src/Permissions/Backend/App.vala"
					return result;
#line 554 "App.c"
				}
#line 176 "../src/Permissions/Backend/App.vala"
				_g_free0 (o);
#line 558 "App.c"
			}
		}
	}
#line 183 "../src/Permissions/Backend/App.vala"
	result = FALSE;
#line 183 "../src/Permissions/Backend/App.vala"
	_g_free0 (negated_permission);
#line 183 "../src/Permissions/Backend/App.vala"
	_g_free0 (_tmp0_);
#line 183 "../src/Permissions/Backend/App.vala"
	return result;
#line 570 "App.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 188 "../src/Permissions/Backend/App.vala"
	return self ? g_object_ref (self) : NULL;
#line 578 "App.c"
}

void
permissions_backend_app_reset_settings_to_standard (PermissionsBackendApp* self)
{
	gchar* overrides_path = NULL;
	gchar* _tmp12_;
	GKeyFile* key_file = NULL;
	GKeyFile* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 186 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 591 "App.c"
	{
		gint i = 0;
#line 187 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 596 "App.c"
		{
			gboolean _tmp0_ = FALSE;
#line 187 "../src/Permissions/Backend/App.vala"
			_tmp0_ = TRUE;
#line 187 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 603 "App.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				PermissionsBackendPermissionSettings* setting = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				PermissionsBackendPermissionSettings* _tmp7_;
				PermissionsBackendPermissionSettings* _tmp8_;
				PermissionsBackendPermissionSettings* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 187 "../src/Permissions/Backend/App.vala"
				if (!_tmp0_) {
#line 617 "App.c"
					gint _tmp1_;
#line 187 "../src/Permissions/Backend/App.vala"
					_tmp1_ = i;
#line 187 "../src/Permissions/Backend/App.vala"
					i = _tmp1_ + 1;
#line 623 "App.c"
				}
#line 187 "../src/Permissions/Backend/App.vala"
				_tmp0_ = FALSE;
#line 187 "../src/Permissions/Backend/App.vala"
				_tmp2_ = self->settings;
#line 187 "../src/Permissions/Backend/App.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 187 "../src/Permissions/Backend/App.vala"
				_tmp4_ = _tmp3_;
#line 187 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp4_)) {
#line 187 "../src/Permissions/Backend/App.vala"
					break;
#line 637 "App.c"
				}
#line 188 "../src/Permissions/Backend/App.vala"
				_tmp5_ = self->settings;
#line 188 "../src/Permissions/Backend/App.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 188 "../src/Permissions/Backend/App.vala"
				_tmp7_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp6_);
#line 188 "../src/Permissions/Backend/App.vala"
				setting = _tmp7_;
#line 189 "../src/Permissions/Backend/App.vala"
				_tmp8_ = setting;
#line 189 "../src/Permissions/Backend/App.vala"
				_tmp9_ = setting;
#line 189 "../src/Permissions/Backend/App.vala"
				_tmp10_ = permissions_backend_permission_settings_get_standard (_tmp9_);
#line 189 "../src/Permissions/Backend/App.vala"
				_tmp11_ = _tmp10_;
#line 189 "../src/Permissions/Backend/App.vala"
				permissions_backend_permission_settings_set_enabled (_tmp8_, _tmp11_);
#line 187 "../src/Permissions/Backend/App.vala"
				_g_object_unref0 (setting);
#line 659 "App.c"
			}
		}
	}
#line 192 "../src/Permissions/Backend/App.vala"
	_tmp12_ = permissions_backend_app_get_overrides_path (self);
#line 192 "../src/Permissions/Backend/App.vala"
	overrides_path = _tmp12_;
#line 194 "../src/Permissions/Backend/App.vala"
	_tmp13_ = g_key_file_new ();
#line 194 "../src/Permissions/Backend/App.vala"
	key_file = _tmp13_;
#line 671 "App.c"
	{
		GKeyFile* _tmp14_;
		const gchar* _tmp15_;
#line 197 "../src/Permissions/Backend/App.vala"
		_tmp14_ = key_file;
#line 197 "../src/Permissions/Backend/App.vala"
		_tmp15_ = overrides_path;
#line 197 "../src/Permissions/Backend/App.vala"
		g_key_file_load_from_file (_tmp14_, _tmp15_, G_KEY_FILE_NONE, &_inner_error0_);
#line 197 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 685 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 197 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 690 "App.c"
				goto __catch0_g_file_error;
			}
#line 197 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 197 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 197 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 197 "../src/Permissions/Backend/App.vala"
			return;
#line 703 "App.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 196 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 196 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 199 "../src/Permissions/Backend/App.vala"
		_tmp16_ = e;
#line 199 "../src/Permissions/Backend/App.vala"
		_tmp17_ = _tmp16_->message;
#line 199 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:199: Couldn't create overrides keyfile: %s", _tmp17_);
#line 196 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 724 "App.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 196 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 196 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 201 "../src/Permissions/Backend/App.vala"
		_tmp18_ = e;
#line 201 "../src/Permissions/Backend/App.vala"
		_tmp19_ = _tmp18_->message;
#line 201 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:201: Couldn't load overrides file: %s", _tmp19_);
#line 196 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 744 "App.c"
	}
	__finally0:
#line 196 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 196 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 196 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/Permissions/Backend/App.vala"
		return;
#line 759 "App.c"
	}
	{
		GKeyFile* _tmp43_;
		const gchar* _tmp44_;
		{
			gint i = 0;
#line 205 "../src/Permissions/Backend/App.vala"
			i = 0;
#line 768 "App.c"
			{
				gboolean _tmp20_ = FALSE;
#line 205 "../src/Permissions/Backend/App.vala"
				_tmp20_ = TRUE;
#line 205 "../src/Permissions/Backend/App.vala"
				while (TRUE) {
#line 775 "App.c"
					GPtrArray* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					PermissionsBackendPermissionSettings* setting = NULL;
					GPtrArray* _tmp25_;
					gconstpointer _tmp26_;
					PermissionsBackendPermissionSettings* _tmp27_;
					gchar** key_value_pair = NULL;
					PermissionsBackendPermissionSettings* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					gchar** _tmp31_;
					gchar** _tmp32_;
					gint key_value_pair_length1;
					gint _key_value_pair_size_;
					gchar* key = NULL;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gboolean _tmp36_ = FALSE;
					GKeyFile* _tmp37_;
#line 205 "../src/Permissions/Backend/App.vala"
					if (!_tmp20_) {
#line 800 "App.c"
						gint _tmp21_;
#line 205 "../src/Permissions/Backend/App.vala"
						_tmp21_ = i;
#line 205 "../src/Permissions/Backend/App.vala"
						i = _tmp21_ + 1;
#line 806 "App.c"
					}
#line 205 "../src/Permissions/Backend/App.vala"
					_tmp20_ = FALSE;
#line 205 "../src/Permissions/Backend/App.vala"
					_tmp22_ = self->settings;
#line 205 "../src/Permissions/Backend/App.vala"
					_tmp23_ = vala_g_ptr_array_get_length (_tmp22_);
#line 205 "../src/Permissions/Backend/App.vala"
					_tmp24_ = _tmp23_;
#line 205 "../src/Permissions/Backend/App.vala"
					if (!(i < _tmp24_)) {
#line 205 "../src/Permissions/Backend/App.vala"
						break;
#line 820 "App.c"
					}
#line 206 "../src/Permissions/Backend/App.vala"
					_tmp25_ = self->settings;
#line 206 "../src/Permissions/Backend/App.vala"
					_tmp26_ = g_ptr_array_index (_tmp25_, (guint) i);
#line 206 "../src/Permissions/Backend/App.vala"
					_tmp27_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp26_);
#line 206 "../src/Permissions/Backend/App.vala"
					setting = _tmp27_;
#line 208 "../src/Permissions/Backend/App.vala"
					_tmp28_ = setting;
#line 208 "../src/Permissions/Backend/App.vala"
					_tmp29_ = permissions_backend_permission_settings_get_context (_tmp28_);
#line 208 "../src/Permissions/Backend/App.vala"
					_tmp30_ = _tmp29_;
#line 208 "../src/Permissions/Backend/App.vala"
					_tmp32_ = _tmp31_ = g_strsplit (_tmp30_, "=", 0);
#line 208 "../src/Permissions/Backend/App.vala"
					key_value_pair = _tmp32_;
#line 208 "../src/Permissions/Backend/App.vala"
					key_value_pair_length1 = _vala_array_length (_tmp31_);
#line 208 "../src/Permissions/Backend/App.vala"
					_key_value_pair_size_ = key_value_pair_length1;
#line 209 "../src/Permissions/Backend/App.vala"
					_tmp33_ = key_value_pair;
#line 209 "../src/Permissions/Backend/App.vala"
					_tmp33__length1 = key_value_pair_length1;
#line 209 "../src/Permissions/Backend/App.vala"
					_tmp34_ = _tmp33_[0];
#line 209 "../src/Permissions/Backend/App.vala"
					_tmp35_ = g_strdup (_tmp34_);
#line 209 "../src/Permissions/Backend/App.vala"
					key = _tmp35_;
#line 211 "../src/Permissions/Backend/App.vala"
					_tmp37_ = key_file;
#line 211 "../src/Permissions/Backend/App.vala"
					if (g_key_file_has_group (_tmp37_, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 858 "App.c"
						gboolean _tmp38_ = FALSE;
						GKeyFile* _tmp39_;
						const gchar* _tmp40_;
#line 211 "../src/Permissions/Backend/App.vala"
						_tmp39_ = key_file;
#line 211 "../src/Permissions/Backend/App.vala"
						_tmp40_ = key;
#line 211 "../src/Permissions/Backend/App.vala"
						_tmp38_ = g_key_file_has_key (_tmp39_, PERMISSIONS_BACKEND_APP_GROUP, _tmp40_, &_inner_error0_);
#line 211 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 211 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 211 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 211 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 878 "App.c"
								goto __catch1_g_key_file_error;
							}
#line 211 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 883 "App.c"
								goto __catch1_g_file_error;
							}
#line 211 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 211 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 211 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 211 "../src/Permissions/Backend/App.vala"
							return;
#line 896 "App.c"
						}
#line 211 "../src/Permissions/Backend/App.vala"
						_tmp36_ = _tmp38_;
#line 900 "App.c"
					} else {
#line 211 "../src/Permissions/Backend/App.vala"
						_tmp36_ = FALSE;
#line 904 "App.c"
					}
#line 211 "../src/Permissions/Backend/App.vala"
					if (_tmp36_) {
#line 908 "App.c"
						GKeyFile* _tmp41_;
						const gchar* _tmp42_;
#line 212 "../src/Permissions/Backend/App.vala"
						_tmp41_ = key_file;
#line 212 "../src/Permissions/Backend/App.vala"
						_tmp42_ = key;
#line 212 "../src/Permissions/Backend/App.vala"
						g_key_file_remove_key (_tmp41_, PERMISSIONS_BACKEND_APP_GROUP, _tmp42_, &_inner_error0_);
#line 212 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 212 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 212 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 212 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 927 "App.c"
								goto __catch1_g_key_file_error;
							}
#line 212 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 932 "App.c"
								goto __catch1_g_file_error;
							}
#line 212 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 212 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 212 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 212 "../src/Permissions/Backend/App.vala"
							return;
#line 945 "App.c"
						}
					}
#line 205 "../src/Permissions/Backend/App.vala"
					_g_free0 (key);
#line 205 "../src/Permissions/Backend/App.vala"
					key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 205 "../src/Permissions/Backend/App.vala"
					_g_object_unref0 (setting);
#line 954 "App.c"
				}
			}
		}
#line 216 "../src/Permissions/Backend/App.vala"
		_tmp43_ = key_file;
#line 216 "../src/Permissions/Backend/App.vala"
		_tmp44_ = overrides_path;
#line 216 "../src/Permissions/Backend/App.vala"
		g_key_file_save_to_file (_tmp43_, _tmp44_, &_inner_error0_);
#line 216 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 968 "App.c"
				goto __catch1_g_key_file_error;
			}
#line 216 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 973 "App.c"
				goto __catch1_g_file_error;
			}
#line 216 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 216 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 216 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 216 "../src/Permissions/Backend/App.vala"
			return;
#line 986 "App.c"
		}
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 204 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 204 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 218 "../src/Permissions/Backend/App.vala"
		_tmp45_ = e;
#line 218 "../src/Permissions/Backend/App.vala"
		_tmp46_ = _tmp45_->message;
#line 218 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:218: Couldn't remove key from overrides keyfile: %s", _tmp46_);
#line 204 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 1007 "App.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 204 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 204 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 220 "../src/Permissions/Backend/App.vala"
		_tmp47_ = e;
#line 220 "../src/Permissions/Backend/App.vala"
		_tmp48_ = _tmp47_->message;
#line 220 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:220: %s", _tmp48_);
#line 204 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 1027 "App.c"
	}
	__finally1:
#line 204 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 204 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 204 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 204 "../src/Permissions/Backend/App.vala"
		return;
#line 1042 "App.c"
	}
#line 186 "../src/Permissions/Backend/App.vala"
	_g_key_file_unref0 (key_file);
#line 186 "../src/Permissions/Backend/App.vala"
	_g_free0 (overrides_path);
#line 1048 "App.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 1062 "App.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1066 "App.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1072 "App.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1077 "App.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1083 "App.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1087 "App.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1091 "App.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1095 "App.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1099 "App.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1103 "App.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1118 "App.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 1127 "App.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1134 "App.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1140 "App.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1148 "App.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1152 "App.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1158 "App.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1163 "App.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1169 "App.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1173 "App.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1177 "App.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1183 "App.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1189 "App.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1201 "App.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1205 "App.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1209 "App.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1214 "App.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1222 "App.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1240 "App.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1246 "App.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1250 "App.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1258 "App.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1267 "App.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1276 "App.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1282 "App.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1290 "App.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1302 "App.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1308 "App.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1312 "App.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1320 "App.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1331 "App.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1340 "App.c"
	}
}

void
permissions_backend_app_save_overrides (PermissionsBackendApp* self)
{
	GError* _inner_error0_ = NULL;
#line 224 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 1350 "App.c"
	{
		gchar* overrides_path = NULL;
		gchar* _tmp0_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp1_;
		GKeyFile* _tmp97_;
		const gchar* _tmp98_;
#line 226 "../src/Permissions/Backend/App.vala"
		_tmp0_ = permissions_backend_app_get_overrides_path (self);
#line 226 "../src/Permissions/Backend/App.vala"
		overrides_path = _tmp0_;
#line 228 "../src/Permissions/Backend/App.vala"
		_tmp1_ = g_key_file_new ();
#line 228 "../src/Permissions/Backend/App.vala"
		key_file = _tmp1_;
#line 1366 "App.c"
		{
			GKeyFile* _tmp2_;
			const gchar* _tmp3_;
#line 231 "../src/Permissions/Backend/App.vala"
			_tmp2_ = key_file;
#line 231 "../src/Permissions/Backend/App.vala"
			_tmp3_ = overrides_path;
#line 231 "../src/Permissions/Backend/App.vala"
			g_key_file_load_from_file (_tmp2_, _tmp3_, G_KEY_FILE_NONE, &_inner_error0_);
#line 231 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1380 "App.c"
					goto __catch1_g_key_file_error;
				}
#line 231 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1385 "App.c"
					goto __catch1_g_file_error;
				}
#line 231 "../src/Permissions/Backend/App.vala"
				_g_key_file_unref0 (key_file);
#line 231 "../src/Permissions/Backend/App.vala"
				_g_free0 (overrides_path);
#line 231 "../src/Permissions/Backend/App.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 231 "../src/Permissions/Backend/App.vala"
				g_clear_error (&_inner_error0_);
#line 231 "../src/Permissions/Backend/App.vala"
				return;
#line 1398 "App.c"
			}
		}
		goto __finally1;
		__catch1_g_key_file_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 230 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 230 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 233 "../src/Permissions/Backend/App.vala"
			_tmp4_ = e;
#line 233 "../src/Permissions/Backend/App.vala"
			_tmp5_ = _tmp4_->message;
#line 233 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:233: Couldn't create overrides keyfile: %s", _tmp5_);
#line 230 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 1419 "App.c"
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 230 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 230 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 235 "../src/Permissions/Backend/App.vala"
			_tmp6_ = e;
#line 235 "../src/Permissions/Backend/App.vala"
			_tmp7_ = _tmp6_->message;
#line 235 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:235: Couldn't load overrides file: %s", _tmp7_);
#line 230 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 1439 "App.c"
		}
		__finally1:
#line 230 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 230 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 230 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1450 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 230 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1455 "App.c"
				goto __catch0_g_file_error;
			}
#line 230 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../src/Permissions/Backend/App.vala"
			return;
#line 1464 "App.c"
		}
		{
			gint i = 0;
#line 238 "../src/Permissions/Backend/App.vala"
			i = 0;
#line 1470 "App.c"
			{
				gboolean _tmp8_ = FALSE;
#line 238 "../src/Permissions/Backend/App.vala"
				_tmp8_ = TRUE;
#line 238 "../src/Permissions/Backend/App.vala"
				while (TRUE) {
#line 1477 "App.c"
					GPtrArray* _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
					PermissionsBackendPermissionSettings* setting = NULL;
					GPtrArray* _tmp13_;
					gconstpointer _tmp14_;
					PermissionsBackendPermissionSettings* _tmp15_;
					gchar** key_value_pair = NULL;
					PermissionsBackendPermissionSettings* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gint key_value_pair_length1;
					gint _key_value_pair_size_;
					gchar* key = NULL;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* value = NULL;
					gchar** _tmp24_;
					gint _tmp24__length1;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gboolean _tmp27_ = FALSE;
					GKeyFile* _tmp28_;
#line 238 "../src/Permissions/Backend/App.vala"
					if (!_tmp8_) {
#line 1507 "App.c"
						gint _tmp9_;
#line 238 "../src/Permissions/Backend/App.vala"
						_tmp9_ = i;
#line 238 "../src/Permissions/Backend/App.vala"
						i = _tmp9_ + 1;
#line 1513 "App.c"
					}
#line 238 "../src/Permissions/Backend/App.vala"
					_tmp8_ = FALSE;
#line 238 "../src/Permissions/Backend/App.vala"
					_tmp10_ = self->settings;
#line 238 "../src/Permissions/Backend/App.vala"
					_tmp11_ = vala_g_ptr_array_get_length (_tmp10_);
#line 238 "../src/Permissions/Backend/App.vala"
					_tmp12_ = _tmp11_;
#line 238 "../src/Permissions/Backend/App.vala"
					if (!(i < _tmp12_)) {
#line 238 "../src/Permissions/Backend/App.vala"
						break;
#line 1527 "App.c"
					}
#line 239 "../src/Permissions/Backend/App.vala"
					_tmp13_ = self->settings;
#line 239 "../src/Permissions/Backend/App.vala"
					_tmp14_ = g_ptr_array_index (_tmp13_, (guint) i);
#line 239 "../src/Permissions/Backend/App.vala"
					_tmp15_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp14_);
#line 239 "../src/Permissions/Backend/App.vala"
					setting = _tmp15_;
#line 241 "../src/Permissions/Backend/App.vala"
					_tmp16_ = setting;
#line 241 "../src/Permissions/Backend/App.vala"
					_tmp17_ = permissions_backend_permission_settings_get_context (_tmp16_);
#line 241 "../src/Permissions/Backend/App.vala"
					_tmp18_ = _tmp17_;
#line 241 "../src/Permissions/Backend/App.vala"
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "=", 0);
#line 241 "../src/Permissions/Backend/App.vala"
					key_value_pair = _tmp20_;
#line 241 "../src/Permissions/Backend/App.vala"
					key_value_pair_length1 = _vala_array_length (_tmp19_);
#line 241 "../src/Permissions/Backend/App.vala"
					_key_value_pair_size_ = key_value_pair_length1;
#line 242 "../src/Permissions/Backend/App.vala"
					_tmp21_ = key_value_pair;
#line 242 "../src/Permissions/Backend/App.vala"
					_tmp21__length1 = key_value_pair_length1;
#line 242 "../src/Permissions/Backend/App.vala"
					_tmp22_ = _tmp21_[0];
#line 242 "../src/Permissions/Backend/App.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 242 "../src/Permissions/Backend/App.vala"
					key = _tmp23_;
#line 244 "../src/Permissions/Backend/App.vala"
					_tmp24_ = key_value_pair;
#line 244 "../src/Permissions/Backend/App.vala"
					_tmp24__length1 = key_value_pair_length1;
#line 244 "../src/Permissions/Backend/App.vala"
					_tmp25_ = _tmp24_[1];
#line 244 "../src/Permissions/Backend/App.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 244 "../src/Permissions/Backend/App.vala"
					value = _tmp26_;
#line 246 "../src/Permissions/Backend/App.vala"
					_tmp28_ = key_file;
#line 246 "../src/Permissions/Backend/App.vala"
					if (g_key_file_has_group (_tmp28_, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 1575 "App.c"
						gboolean _tmp29_ = FALSE;
						GKeyFile* _tmp30_;
						const gchar* _tmp31_;
#line 246 "../src/Permissions/Backend/App.vala"
						_tmp30_ = key_file;
#line 246 "../src/Permissions/Backend/App.vala"
						_tmp31_ = key;
#line 246 "../src/Permissions/Backend/App.vala"
						_tmp29_ = g_key_file_has_key (_tmp30_, PERMISSIONS_BACKEND_APP_GROUP, _tmp31_, &_inner_error0_);
#line 246 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/Permissions/Backend/App.vala"
							_g_free0 (value);
#line 246 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 246 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 246 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 246 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 246 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 246 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1601 "App.c"
								goto __catch0_g_key_file_error;
							}
#line 246 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1606 "App.c"
								goto __catch0_g_file_error;
							}
#line 246 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 246 "../src/Permissions/Backend/App.vala"
							return;
#line 1615 "App.c"
						}
#line 246 "../src/Permissions/Backend/App.vala"
						_tmp27_ = _tmp29_;
#line 1619 "App.c"
					} else {
#line 246 "../src/Permissions/Backend/App.vala"
						_tmp27_ = FALSE;
#line 1623 "App.c"
					}
#line 246 "../src/Permissions/Backend/App.vala"
					if (_tmp27_) {
#line 1627 "App.c"
						{
							gchar* existing_value = NULL;
							GKeyFile* _tmp32_;
							const gchar* _tmp33_;
							gchar* _tmp34_;
							gchar** existing_values = NULL;
							const gchar* _tmp35_;
							gchar** _tmp36_;
							gchar** _tmp37_;
							gint existing_values_length1;
							gint _existing_values_size_;
							GeeHashSet* values_list = NULL;
							GeeHashSet* _tmp38_;
							gchar** _tmp39_;
							gint _tmp39__length1;
							gboolean _tmp46_ = FALSE;
							GeeHashSet* _tmp47_;
							const gchar* _tmp48_;
							gchar** new_values = NULL;
							GeeHashSet* _tmp68_;
							gint _tmp69_ = 0;
							gpointer* _tmp70_;
							gint new_values_length1;
							gint _new_values_size_;
							gchar* new_value = NULL;
							gchar** _tmp71_;
							gint _tmp71__length1;
							gchar* _tmp72_;
							const gchar* _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
#line 248 "../src/Permissions/Backend/App.vala"
							_tmp32_ = key_file;
#line 248 "../src/Permissions/Backend/App.vala"
							_tmp33_ = key;
#line 248 "../src/Permissions/Backend/App.vala"
							_tmp34_ = g_key_file_get_value (_tmp32_, PERMISSIONS_BACKEND_APP_GROUP, _tmp33_, &_inner_error0_);
#line 248 "../src/Permissions/Backend/App.vala"
							existing_value = _tmp34_;
#line 248 "../src/Permissions/Backend/App.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/Permissions/Backend/App.vala"
								if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1671 "App.c"
									goto __catch2_g_key_file_error;
								}
#line 248 "../src/Permissions/Backend/App.vala"
								_g_free0 (value);
#line 248 "../src/Permissions/Backend/App.vala"
								_g_free0 (key);
#line 248 "../src/Permissions/Backend/App.vala"
								key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/Permissions/Backend/App.vala"
								_g_object_unref0 (setting);
#line 248 "../src/Permissions/Backend/App.vala"
								_g_key_file_unref0 (key_file);
#line 248 "../src/Permissions/Backend/App.vala"
								_g_free0 (overrides_path);
#line 248 "../src/Permissions/Backend/App.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/Permissions/Backend/App.vala"
								g_clear_error (&_inner_error0_);
#line 248 "../src/Permissions/Backend/App.vala"
								return;
#line 1692 "App.c"
							}
#line 250 "../src/Permissions/Backend/App.vala"
							_tmp35_ = existing_value;
#line 250 "../src/Permissions/Backend/App.vala"
							_tmp37_ = _tmp36_ = g_strsplit (_tmp35_, ";", 0);
#line 250 "../src/Permissions/Backend/App.vala"
							existing_values = _tmp37_;
#line 250 "../src/Permissions/Backend/App.vala"
							existing_values_length1 = _vala_array_length (_tmp36_);
#line 250 "../src/Permissions/Backend/App.vala"
							_existing_values_size_ = existing_values_length1;
#line 251 "../src/Permissions/Backend/App.vala"
							_tmp38_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 251 "../src/Permissions/Backend/App.vala"
							values_list = _tmp38_;
#line 253 "../src/Permissions/Backend/App.vala"
							_tmp39_ = existing_values;
#line 253 "../src/Permissions/Backend/App.vala"
							_tmp39__length1 = existing_values_length1;
#line 1712 "App.c"
							{
								gchar** existing_value_entry_collection = NULL;
								gint existing_value_entry_collection_length1 = 0;
								gint _existing_value_entry_collection_size_ = 0;
								gint existing_value_entry_it = 0;
#line 253 "../src/Permissions/Backend/App.vala"
								existing_value_entry_collection = _tmp39_;
#line 253 "../src/Permissions/Backend/App.vala"
								existing_value_entry_collection_length1 = _tmp39__length1;
#line 253 "../src/Permissions/Backend/App.vala"
								for (existing_value_entry_it = 0; existing_value_entry_it < existing_value_entry_collection_length1; existing_value_entry_it = existing_value_entry_it + 1) {
#line 1724 "App.c"
									gchar* _tmp40_;
									gchar* existing_value_entry = NULL;
#line 253 "../src/Permissions/Backend/App.vala"
									_tmp40_ = g_strdup (existing_value_entry_collection[existing_value_entry_it]);
#line 253 "../src/Permissions/Backend/App.vala"
									existing_value_entry = _tmp40_;
#line 1731 "App.c"
									{
										const gchar* _tmp41_;
										gint _tmp42_;
										gint _tmp43_;
#line 254 "../src/Permissions/Backend/App.vala"
										_tmp41_ = existing_value_entry;
#line 254 "../src/Permissions/Backend/App.vala"
										_tmp42_ = strlen (_tmp41_);
#line 254 "../src/Permissions/Backend/App.vala"
										_tmp43_ = _tmp42_;
#line 254 "../src/Permissions/Backend/App.vala"
										if (_tmp43_ > 0) {
#line 1744 "App.c"
											GeeHashSet* _tmp44_;
											const gchar* _tmp45_;
#line 255 "../src/Permissions/Backend/App.vala"
											_tmp44_ = values_list;
#line 255 "../src/Permissions/Backend/App.vala"
											_tmp45_ = existing_value_entry;
#line 255 "../src/Permissions/Backend/App.vala"
											gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, _tmp45_);
#line 1753 "App.c"
										}
#line 253 "../src/Permissions/Backend/App.vala"
										_g_free0 (existing_value_entry);
#line 1757 "App.c"
									}
								}
							}
#line 259 "../src/Permissions/Backend/App.vala"
							_tmp47_ = values_list;
#line 259 "../src/Permissions/Backend/App.vala"
							_tmp48_ = value;
#line 259 "../src/Permissions/Backend/App.vala"
							if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp47_, _tmp48_)) {
#line 1767 "App.c"
								PermissionsBackendPermissionSettings* _tmp49_;
								gboolean _tmp50_;
								gboolean _tmp51_;
								PermissionsBackendPermissionSettings* _tmp52_;
								gboolean _tmp53_;
								gboolean _tmp54_;
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp49_ = setting;
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp50_ = permissions_backend_permission_settings_get_enabled (_tmp49_);
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp51_ = _tmp50_;
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp52_ = setting;
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp53_ = permissions_backend_permission_settings_get_standard (_tmp52_);
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp54_ = _tmp53_;
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp46_ = _tmp51_ == _tmp54_;
#line 1788 "App.c"
							} else {
#line 259 "../src/Permissions/Backend/App.vala"
								_tmp46_ = FALSE;
#line 1792 "App.c"
							}
#line 259 "../src/Permissions/Backend/App.vala"
							if (_tmp46_) {
#line 1796 "App.c"
								GeeHashSet* _tmp55_;
								const gchar* _tmp56_;
#line 260 "../src/Permissions/Backend/App.vala"
								_tmp55_ = values_list;
#line 260 "../src/Permissions/Backend/App.vala"
								_tmp56_ = value;
#line 260 "../src/Permissions/Backend/App.vala"
								gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp55_, _tmp56_);
#line 1805 "App.c"
							} else {
								gboolean _tmp57_ = FALSE;
								GeeHashSet* _tmp58_;
								const gchar* _tmp59_;
#line 261 "../src/Permissions/Backend/App.vala"
								_tmp58_ = values_list;
#line 261 "../src/Permissions/Backend/App.vala"
								_tmp59_ = value;
#line 261 "../src/Permissions/Backend/App.vala"
								if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp58_, _tmp59_)) {
#line 1816 "App.c"
									PermissionsBackendPermissionSettings* _tmp60_;
									gboolean _tmp61_;
									gboolean _tmp62_;
									PermissionsBackendPermissionSettings* _tmp63_;
									gboolean _tmp64_;
									gboolean _tmp65_;
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp60_ = setting;
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp61_ = permissions_backend_permission_settings_get_enabled (_tmp60_);
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp62_ = _tmp61_;
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp63_ = setting;
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp64_ = permissions_backend_permission_settings_get_standard (_tmp63_);
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp65_ = _tmp64_;
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp57_ = _tmp62_ != _tmp65_;
#line 1837 "App.c"
								} else {
#line 261 "../src/Permissions/Backend/App.vala"
									_tmp57_ = FALSE;
#line 1841 "App.c"
								}
#line 261 "../src/Permissions/Backend/App.vala"
								if (_tmp57_) {
#line 1845 "App.c"
									GeeHashSet* _tmp66_;
									const gchar* _tmp67_;
#line 262 "../src/Permissions/Backend/App.vala"
									_tmp66_ = values_list;
#line 262 "../src/Permissions/Backend/App.vala"
									_tmp67_ = value;
#line 262 "../src/Permissions/Backend/App.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp66_, _tmp67_);
#line 1854 "App.c"
								}
							}
#line 265 "../src/Permissions/Backend/App.vala"
							_tmp68_ = values_list;
#line 265 "../src/Permissions/Backend/App.vala"
							_tmp70_ = gee_collection_to_array ((GeeCollection*) _tmp68_, &_tmp69_);
#line 265 "../src/Permissions/Backend/App.vala"
							new_values = _tmp70_;
#line 265 "../src/Permissions/Backend/App.vala"
							new_values_length1 = _tmp69_;
#line 265 "../src/Permissions/Backend/App.vala"
							_new_values_size_ = new_values_length1;
#line 266 "../src/Permissions/Backend/App.vala"
							_tmp71_ = new_values;
#line 266 "../src/Permissions/Backend/App.vala"
							_tmp71__length1 = new_values_length1;
#line 266 "../src/Permissions/Backend/App.vala"
							_tmp72_ = _vala_g_strjoinv (";", _tmp71_, (gint) _tmp71__length1);
#line 266 "../src/Permissions/Backend/App.vala"
							new_value = _tmp72_;
#line 268 "../src/Permissions/Backend/App.vala"
							_tmp73_ = new_value;
#line 268 "../src/Permissions/Backend/App.vala"
							_tmp74_ = strlen (_tmp73_);
#line 268 "../src/Permissions/Backend/App.vala"
							_tmp75_ = _tmp74_;
#line 268 "../src/Permissions/Backend/App.vala"
							if (_tmp75_ > 0) {
#line 1883 "App.c"
								GKeyFile* _tmp76_;
								const gchar* _tmp77_;
								const gchar* _tmp78_;
#line 269 "../src/Permissions/Backend/App.vala"
								_tmp76_ = key_file;
#line 269 "../src/Permissions/Backend/App.vala"
								_tmp77_ = key;
#line 269 "../src/Permissions/Backend/App.vala"
								_tmp78_ = new_value;
#line 269 "../src/Permissions/Backend/App.vala"
								g_key_file_set_value (_tmp76_, PERMISSIONS_BACKEND_APP_GROUP, _tmp77_, _tmp78_);
#line 1895 "App.c"
							} else {
								GKeyFile* _tmp79_;
								const gchar* _tmp80_;
								gchar** _tmp81_ = NULL;
								GKeyFile* _tmp82_;
								gsize _tmp83_ = 0;
								gchar** _tmp84_;
								gint _tmp81__length1;
								gint __tmp81__size_;
#line 271 "../src/Permissions/Backend/App.vala"
								_tmp79_ = key_file;
#line 271 "../src/Permissions/Backend/App.vala"
								_tmp80_ = key;
#line 271 "../src/Permissions/Backend/App.vala"
								g_key_file_remove_key (_tmp79_, PERMISSIONS_BACKEND_APP_GROUP, _tmp80_, &_inner_error0_);
#line 271 "../src/Permissions/Backend/App.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/Permissions/Backend/App.vala"
									_g_free0 (new_value);
#line 271 "../src/Permissions/Backend/App.vala"
									new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (values_list);
#line 271 "../src/Permissions/Backend/App.vala"
									existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_free0 (existing_value);
#line 271 "../src/Permissions/Backend/App.vala"
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1925 "App.c"
										goto __catch2_g_key_file_error;
									}
#line 271 "../src/Permissions/Backend/App.vala"
									_g_free0 (value);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_free0 (key);
#line 271 "../src/Permissions/Backend/App.vala"
									key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (setting);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_key_file_unref0 (key_file);
#line 271 "../src/Permissions/Backend/App.vala"
									_g_free0 (overrides_path);
#line 271 "../src/Permissions/Backend/App.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/Permissions/Backend/App.vala"
									g_clear_error (&_inner_error0_);
#line 271 "../src/Permissions/Backend/App.vala"
									return;
#line 1946 "App.c"
								}
#line 273 "../src/Permissions/Backend/App.vala"
								_tmp82_ = key_file;
#line 273 "../src/Permissions/Backend/App.vala"
								_tmp84_ = g_key_file_get_keys (_tmp82_, PERMISSIONS_BACKEND_APP_GROUP, &_tmp83_, &_inner_error0_);
#line 273 "../src/Permissions/Backend/App.vala"
								_tmp81_ = _tmp84_;
#line 273 "../src/Permissions/Backend/App.vala"
								_tmp81__length1 = _tmp83_;
#line 273 "../src/Permissions/Backend/App.vala"
								__tmp81__size_ = _tmp81__length1;
#line 273 "../src/Permissions/Backend/App.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/Permissions/Backend/App.vala"
									_g_free0 (new_value);
#line 273 "../src/Permissions/Backend/App.vala"
									new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (values_list);
#line 273 "../src/Permissions/Backend/App.vala"
									existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_free0 (existing_value);
#line 273 "../src/Permissions/Backend/App.vala"
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1972 "App.c"
										goto __catch2_g_key_file_error;
									}
#line 273 "../src/Permissions/Backend/App.vala"
									_g_free0 (value);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_free0 (key);
#line 273 "../src/Permissions/Backend/App.vala"
									key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (setting);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_key_file_unref0 (key_file);
#line 273 "../src/Permissions/Backend/App.vala"
									_g_free0 (overrides_path);
#line 273 "../src/Permissions/Backend/App.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/Permissions/Backend/App.vala"
									g_clear_error (&_inner_error0_);
#line 273 "../src/Permissions/Backend/App.vala"
									return;
#line 1993 "App.c"
								}
#line 273 "../src/Permissions/Backend/App.vala"
								if (_tmp81__length1 == 0) {
#line 1997 "App.c"
									GKeyFile* _tmp85_;
#line 274 "../src/Permissions/Backend/App.vala"
									_tmp85_ = key_file;
#line 274 "../src/Permissions/Backend/App.vala"
									g_key_file_remove_group (_tmp85_, PERMISSIONS_BACKEND_APP_GROUP, &_inner_error0_);
#line 274 "../src/Permissions/Backend/App.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../src/Permissions/Backend/App.vala"
										_tmp81_ = (_vala_array_free (_tmp81_, _tmp81__length1, (GDestroyNotify) g_free), NULL);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_free0 (new_value);
#line 274 "../src/Permissions/Backend/App.vala"
										new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_object_unref0 (values_list);
#line 274 "../src/Permissions/Backend/App.vala"
										existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_free0 (existing_value);
#line 274 "../src/Permissions/Backend/App.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2019 "App.c"
											goto __catch2_g_key_file_error;
										}
#line 274 "../src/Permissions/Backend/App.vala"
										_g_free0 (value);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_free0 (key);
#line 274 "../src/Permissions/Backend/App.vala"
										key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_object_unref0 (setting);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_key_file_unref0 (key_file);
#line 274 "../src/Permissions/Backend/App.vala"
										_g_free0 (overrides_path);
#line 274 "../src/Permissions/Backend/App.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "../src/Permissions/Backend/App.vala"
										g_clear_error (&_inner_error0_);
#line 274 "../src/Permissions/Backend/App.vala"
										return;
#line 2040 "App.c"
									}
								}
#line 268 "../src/Permissions/Backend/App.vala"
								_tmp81_ = (_vala_array_free (_tmp81_, _tmp81__length1, (GDestroyNotify) g_free), NULL);
#line 2045 "App.c"
							}
#line 247 "../src/Permissions/Backend/App.vala"
							_g_free0 (new_value);
#line 247 "../src/Permissions/Backend/App.vala"
							new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (values_list);
#line 247 "../src/Permissions/Backend/App.vala"
							existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_free0 (existing_value);
#line 2057 "App.c"
						}
						goto __finally2;
						__catch2_g_key_file_error:
						{
							GError* e = NULL;
							GError* _tmp86_;
							const gchar* _tmp87_;
#line 247 "../src/Permissions/Backend/App.vala"
							e = _inner_error0_;
#line 247 "../src/Permissions/Backend/App.vala"
							_inner_error0_ = NULL;
#line 278 "../src/Permissions/Backend/App.vala"
							_tmp86_ = e;
#line 278 "../src/Permissions/Backend/App.vala"
							_tmp87_ = _tmp86_->message;
#line 278 "../src/Permissions/Backend/App.vala"
							g_debug ("App.vala:278: %s", _tmp87_);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_error_free0 (e);
#line 2077 "App.c"
						}
						__finally2:
#line 247 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/Permissions/Backend/App.vala"
							_g_free0 (value);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 247 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 247 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 247 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2096 "App.c"
								goto __catch0_g_key_file_error;
							}
#line 247 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2101 "App.c"
								goto __catch0_g_file_error;
							}
#line 247 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 247 "../src/Permissions/Backend/App.vala"
							return;
#line 2110 "App.c"
						}
					} else {
						PermissionsBackendPermissionSettings* _tmp88_;
						gboolean _tmp89_;
						gboolean _tmp90_;
						PermissionsBackendPermissionSettings* _tmp91_;
						gboolean _tmp92_;
						gboolean _tmp93_;
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp88_ = setting;
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp89_ = permissions_backend_permission_settings_get_enabled (_tmp88_);
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp90_ = _tmp89_;
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp91_ = setting;
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp92_ = permissions_backend_permission_settings_get_standard (_tmp91_);
#line 281 "../src/Permissions/Backend/App.vala"
						_tmp93_ = _tmp92_;
#line 281 "../src/Permissions/Backend/App.vala"
						if (_tmp90_ != _tmp93_) {
#line 2133 "App.c"
							GKeyFile* _tmp94_;
							const gchar* _tmp95_;
							const gchar* _tmp96_;
#line 282 "../src/Permissions/Backend/App.vala"
							_tmp94_ = key_file;
#line 282 "../src/Permissions/Backend/App.vala"
							_tmp95_ = key;
#line 282 "../src/Permissions/Backend/App.vala"
							_tmp96_ = value;
#line 282 "../src/Permissions/Backend/App.vala"
							g_key_file_set_value (_tmp94_, PERMISSIONS_BACKEND_APP_GROUP, _tmp95_, _tmp96_);
#line 2145 "App.c"
						}
					}
#line 238 "../src/Permissions/Backend/App.vala"
					_g_free0 (value);
#line 238 "../src/Permissions/Backend/App.vala"
					_g_free0 (key);
#line 238 "../src/Permissions/Backend/App.vala"
					key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 238 "../src/Permissions/Backend/App.vala"
					_g_object_unref0 (setting);
#line 2156 "App.c"
				}
			}
		}
#line 287 "../src/Permissions/Backend/App.vala"
		_tmp97_ = key_file;
#line 287 "../src/Permissions/Backend/App.vala"
		_tmp98_ = overrides_path;
#line 287 "../src/Permissions/Backend/App.vala"
		g_key_file_save_to_file (_tmp97_, _tmp98_, &_inner_error0_);
#line 287 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 287 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 287 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2174 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 287 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2179 "App.c"
				goto __catch0_g_file_error;
			}
#line 287 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 287 "../src/Permissions/Backend/App.vala"
			return;
#line 2188 "App.c"
		}
#line 225 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 225 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 2194 "App.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp99_;
		const gchar* _tmp100_;
#line 225 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 225 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 289 "../src/Permissions/Backend/App.vala"
		_tmp99_ = e;
#line 289 "../src/Permissions/Backend/App.vala"
		_tmp100_ = _tmp99_->message;
#line 289 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:289: Couldn't save overrides keyfile: %s", _tmp100_);
#line 225 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2214 "App.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp101_;
		const gchar* _tmp102_;
#line 225 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 225 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 291 "../src/Permissions/Backend/App.vala"
		_tmp101_ = e;
#line 291 "../src/Permissions/Backend/App.vala"
		_tmp102_ = _tmp101_->message;
#line 291 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:291: %s", _tmp102_);
#line 225 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2234 "App.c"
	}
	__finally0:
#line 225 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 225 "../src/Permissions/Backend/App.vala"
		return;
#line 2245 "App.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 296 "../src/Permissions/Backend/App.vala"
	var = (g_free (var), NULL);
#line 2254 "App.c"
}

static GPtrArray*
permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                     GKeyFile* key_file)
{
	GPtrArray* permissions = NULL;
	GPtrArray* _tmp0_;
	GError* _inner_error0_ = NULL;
	GPtrArray* result;
#line 295 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 295 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (key_file != NULL, NULL);
#line 296 "../src/Permissions/Backend/App.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 296 "../src/Permissions/Backend/App.vala"
	permissions = _tmp0_;
#line 298 "../src/Permissions/Backend/App.vala"
	if (!g_key_file_has_group (key_file, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 299 "../src/Permissions/Backend/App.vala"
		result = permissions;
#line 299 "../src/Permissions/Backend/App.vala"
		return result;
#line 2279 "App.c"
	}
	{
		gchar** keys = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint keys_length1;
		gint _keys_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 303 "../src/Permissions/Backend/App.vala"
		_tmp2_ = g_key_file_get_keys (key_file, PERMISSIONS_BACKEND_APP_GROUP, &_tmp1_, &_inner_error0_);
#line 303 "../src/Permissions/Backend/App.vala"
		keys = _tmp2_;
#line 303 "../src/Permissions/Backend/App.vala"
		keys_length1 = _tmp1_;
#line 303 "../src/Permissions/Backend/App.vala"
		_keys_size_ = keys_length1;
#line 303 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2299 "App.c"
			goto __catch0_g_error;
		}
#line 305 "../src/Permissions/Backend/App.vala"
		_tmp3_ = keys;
#line 305 "../src/Permissions/Backend/App.vala"
		_tmp3__length1 = keys_length1;
#line 2306 "App.c"
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 305 "../src/Permissions/Backend/App.vala"
			key_collection = _tmp3_;
#line 305 "../src/Permissions/Backend/App.vala"
			key_collection_length1 = _tmp3__length1;
#line 305 "../src/Permissions/Backend/App.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 2318 "App.c"
				const gchar* key = NULL;
#line 305 "../src/Permissions/Backend/App.vala"
				key = key_collection[key_it];
#line 2322 "App.c"
				{
					gchar** values = NULL;
					const gchar* _tmp4_;
					gsize _tmp5_ = 0;
					gchar** _tmp6_;
					gint values_length1;
					gint _values_size_;
					gchar** _tmp7_;
					gint _tmp7__length1;
#line 306 "../src/Permissions/Backend/App.vala"
					_tmp4_ = key;
#line 306 "../src/Permissions/Backend/App.vala"
					_tmp6_ = g_key_file_get_string_list (key_file, PERMISSIONS_BACKEND_APP_GROUP, _tmp4_, &_tmp5_, &_inner_error0_);
#line 306 "../src/Permissions/Backend/App.vala"
					values = _tmp6_;
#line 306 "../src/Permissions/Backend/App.vala"
					values_length1 = _tmp5_;
#line 306 "../src/Permissions/Backend/App.vala"
					_values_size_ = values_length1;
#line 306 "../src/Permissions/Backend/App.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "../src/Permissions/Backend/App.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 2346 "App.c"
						goto __catch0_g_error;
					}
#line 307 "../src/Permissions/Backend/App.vala"
					_tmp7_ = values;
#line 307 "../src/Permissions/Backend/App.vala"
					_tmp7__length1 = values_length1;
#line 2353 "App.c"
					{
						gchar** value_collection = NULL;
						gint value_collection_length1 = 0;
						gint _value_collection_size_ = 0;
						gint value_it = 0;
#line 307 "../src/Permissions/Backend/App.vala"
						value_collection = _tmp7_;
#line 307 "../src/Permissions/Backend/App.vala"
						value_collection_length1 = _tmp7__length1;
#line 307 "../src/Permissions/Backend/App.vala"
						for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 2365 "App.c"
							const gchar* value = NULL;
#line 307 "../src/Permissions/Backend/App.vala"
							value = value_collection[value_it];
#line 2369 "App.c"
							{
								const gchar* _tmp8_;
								gint _tmp9_;
								gint _tmp10_;
								GPtrArray* _tmp11_;
								const gchar* _tmp12_;
								const gchar* _tmp13_;
								gchar* _tmp14_;
#line 308 "../src/Permissions/Backend/App.vala"
								_tmp8_ = value;
#line 308 "../src/Permissions/Backend/App.vala"
								_tmp9_ = strlen (_tmp8_);
#line 308 "../src/Permissions/Backend/App.vala"
								_tmp10_ = _tmp9_;
#line 308 "../src/Permissions/Backend/App.vala"
								if (_tmp10_ == 0) {
#line 309 "../src/Permissions/Backend/App.vala"
									break;
#line 2388 "App.c"
								}
#line 312 "../src/Permissions/Backend/App.vala"
								_tmp11_ = permissions;
#line 312 "../src/Permissions/Backend/App.vala"
								_tmp12_ = key;
#line 312 "../src/Permissions/Backend/App.vala"
								_tmp13_ = value;
#line 312 "../src/Permissions/Backend/App.vala"
								_tmp14_ = g_strdup_printf ("%s=%s", _tmp12_, _tmp13_);
#line 312 "../src/Permissions/Backend/App.vala"
								g_ptr_array_add (_tmp11_, _tmp14_);
#line 2400 "App.c"
							}
						}
					}
#line 305 "../src/Permissions/Backend/App.vala"
					values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 2406 "App.c"
				}
			}
		}
#line 302 "../src/Permissions/Backend/App.vala"
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 2412 "App.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 302 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 302 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 316 "../src/Permissions/Backend/App.vala"
		_tmp15_ = e;
#line 316 "../src/Permissions/Backend/App.vala"
		_tmp16_ = _tmp15_->message;
#line 316 "../src/Permissions/Backend/App.vala"
		g_critical ("App.vala:316: %s", _tmp16_);
#line 302 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2432 "App.c"
	}
	__finally0:
#line 302 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 302 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (permissions);
#line 302 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 302 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 302 "../src/Permissions/Backend/App.vala"
		return NULL;
#line 2445 "App.c"
	}
#line 319 "../src/Permissions/Backend/App.vala"
	result = permissions;
#line 319 "../src/Permissions/Backend/App.vala"
	return result;
#line 2451 "App.c"
}

FlatpakInstalledRef*
permissions_backend_app_get_installed_ref (PermissionsBackendApp* self)
{
	FlatpakInstalledRef* result;
	FlatpakInstalledRef* _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_installed_ref;
#line 25 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
	return result;
#line 2467 "App.c"
}

static void
permissions_backend_app_set_installed_ref (PermissionsBackendApp* self,
                                           FlatpakInstalledRef* value)
{
	FlatpakInstalledRef* old_value;
#line 25 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_installed_ref (self);
#line 25 "../src/Permissions/Backend/App.vala"
	if (old_value != value) {
#line 2481 "App.c"
		FlatpakInstalledRef* _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (self->priv->_installed_ref);
#line 25 "../src/Permissions/Backend/App.vala"
		self->priv->_installed_ref = _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY]);
#line 2491 "App.c"
	}
}

const gchar*
permissions_backend_app_get_id (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_id;
#line 26 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
	return result;
#line 2508 "App.c"
}

static void
permissions_backend_app_set_id (PermissionsBackendApp* self,
                                const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_id (self);
#line 26 "../src/Permissions/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2522 "App.c"
		gchar* _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Permissions/Backend/App.vala"
		_g_free0 (self->priv->_id);
#line 26 "../src/Permissions/Backend/App.vala"
		self->priv->_id = _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY]);
#line 2532 "App.c"
	}
}

const gchar*
permissions_backend_app_get_name (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_name;
#line 27 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
	return result;
#line 2549 "App.c"
}

static void
permissions_backend_app_set_name (PermissionsBackendApp* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 27 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_name (self);
#line 27 "../src/Permissions/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2563 "App.c"
		gchar* _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Permissions/Backend/App.vala"
		_g_free0 (self->priv->_name);
#line 27 "../src/Permissions/Backend/App.vala"
		self->priv->_name = _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY]);
#line 2573 "App.c"
	}
}

const gchar*
permissions_backend_app_get_description (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_description;
#line 28 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 28 "../src/Permissions/Backend/App.vala"
	return result;
#line 2590 "App.c"
}

static void
permissions_backend_app_set_description (PermissionsBackendApp* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 28 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_description (self);
#line 28 "../src/Permissions/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2604 "App.c"
		gchar* _tmp0_;
#line 28 "../src/Permissions/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/Permissions/Backend/App.vala"
		_g_free0 (self->priv->_description);
#line 28 "../src/Permissions/Backend/App.vala"
		self->priv->_description = _tmp0_;
#line 28 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY]);
#line 2614 "App.c"
	}
}

GIcon*
permissions_backend_app_get_icon (PermissionsBackendApp* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 29 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_icon;
#line 29 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 29 "../src/Permissions/Backend/App.vala"
	return result;
#line 2631 "App.c"
}

static void
permissions_backend_app_set_icon (PermissionsBackendApp* self,
                                  GIcon* value)
{
	GIcon* old_value;
#line 29 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_icon (self);
#line 29 "../src/Permissions/Backend/App.vala"
	if (old_value != value) {
#line 2645 "App.c"
		GIcon* _tmp0_;
#line 29 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (self->priv->_icon);
#line 29 "../src/Permissions/Backend/App.vala"
		self->priv->_icon = _tmp0_;
#line 29 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ICON_PROPERTY]);
#line 2655 "App.c"
	}
}

GHashTable*
permissions_backend_app_get_permission_names (void)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 32 "../src/Permissions/Backend/App.vala"
	_tmp0_ = permissions_backend_app__permission_names;
#line 32 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 32 "../src/Permissions/Backend/App.vala"
	return result;
#line 2670 "App.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 32 "../src/Permissions/Backend/App.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 2678 "App.c"
}

static void
permissions_backend_app_set_permission_names (GHashTable* value)
{
	GHashTable* _tmp0_;
#line 32 "../src/Permissions/Backend/App.vala"
	_tmp0_ = _g_hash_table_ref0 (value);
#line 32 "../src/Permissions/Backend/App.vala"
	_g_hash_table_unref0 (permissions_backend_app__permission_names);
#line 32 "../src/Permissions/Backend/App.vala"
	permissions_backend_app__permission_names = _tmp0_;
#line 2691 "App.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 52 "../src/Permissions/Backend/App.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 52 "../src/Permissions/Backend/App.vala"
	return _data5_;
#line 2701 "App.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 52 "../src/Permissions/Backend/App.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2711 "App.c"
		PermissionsBackendApp* self;
#line 52 "../src/Permissions/Backend/App.vala"
		self = _data5_->self;
#line 52 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (_data5_->current_permissions);
#line 52 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (_data5_->permissions);
#line 52 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (self);
#line 52 "../src/Permissions/Backend/App.vala"
		g_slice_free (Block5Data, _data5_);
#line 2723 "App.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 65 "../src/Permissions/Backend/App.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2732 "App.c"
}

static void
_permissions_backend_app___lambda4_ (Block5Data* _data5_,
                                     const gchar* key)
{
	PermissionsBackendApp* self;
	gboolean standard = FALSE;
	gboolean enabled = FALSE;
	PermissionsBackendPermissionSettings* s = NULL;
	PermissionsBackendPermissionSettings* _tmp18_ = NULL;
	GPtrArray* _tmp19_;
	PermissionsBackendPermissionSettings* _tmp20_;
	PermissionsBackendPermissionSettings* _tmp21_;
#line 116 "../src/Permissions/Backend/App.vala"
	self = _data5_->self;
#line 116 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (key != NULL);
#line 117 "../src/Permissions/Backend/App.vala"
	standard = FALSE;
#line 118 "../src/Permissions/Backend/App.vala"
	enabled = FALSE;
#line 2755 "App.c"
	{
		gint i = 0;
#line 120 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 2760 "App.c"
		{
			gboolean _tmp0_ = FALSE;
#line 120 "../src/Permissions/Backend/App.vala"
			_tmp0_ = TRUE;
#line 120 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 2767 "App.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gchar* permission = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
#line 120 "../src/Permissions/Backend/App.vala"
				if (!_tmp0_) {
#line 2778 "App.c"
					gint _tmp1_;
#line 120 "../src/Permissions/Backend/App.vala"
					_tmp1_ = i;
#line 120 "../src/Permissions/Backend/App.vala"
					i = _tmp1_ + 1;
#line 2784 "App.c"
				}
#line 120 "../src/Permissions/Backend/App.vala"
				_tmp0_ = FALSE;
#line 120 "../src/Permissions/Backend/App.vala"
				_tmp2_ = _data5_->permissions;
#line 120 "../src/Permissions/Backend/App.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 120 "../src/Permissions/Backend/App.vala"
				_tmp4_ = _tmp3_;
#line 120 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp4_)) {
#line 120 "../src/Permissions/Backend/App.vala"
					break;
#line 2798 "App.c"
				}
#line 121 "../src/Permissions/Backend/App.vala"
				_tmp5_ = _data5_->permissions;
#line 121 "../src/Permissions/Backend/App.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 121 "../src/Permissions/Backend/App.vala"
				_tmp7_ = g_strdup ((const gchar*) _tmp6_);
#line 121 "../src/Permissions/Backend/App.vala"
				permission = _tmp7_;
#line 122 "../src/Permissions/Backend/App.vala"
				_tmp8_ = permission;
#line 122 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (key, _tmp8_) == 0) {
#line 123 "../src/Permissions/Backend/App.vala"
					standard = TRUE;
#line 124 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 124 "../src/Permissions/Backend/App.vala"
					break;
#line 2818 "App.c"
				}
#line 120 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 2822 "App.c"
			}
		}
	}
	{
		gint i = 0;
#line 128 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 2830 "App.c"
		{
			gboolean _tmp9_ = FALSE;
#line 128 "../src/Permissions/Backend/App.vala"
			_tmp9_ = TRUE;
#line 128 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 2837 "App.c"
				GPtrArray* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gchar* permission = NULL;
				GPtrArray* _tmp14_;
				gconstpointer _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
#line 128 "../src/Permissions/Backend/App.vala"
				if (!_tmp9_) {
#line 2848 "App.c"
					gint _tmp10_;
#line 128 "../src/Permissions/Backend/App.vala"
					_tmp10_ = i;
#line 128 "../src/Permissions/Backend/App.vala"
					i = _tmp10_ + 1;
#line 2854 "App.c"
				}
#line 128 "../src/Permissions/Backend/App.vala"
				_tmp9_ = FALSE;
#line 128 "../src/Permissions/Backend/App.vala"
				_tmp11_ = _data5_->current_permissions;
#line 128 "../src/Permissions/Backend/App.vala"
				_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 128 "../src/Permissions/Backend/App.vala"
				_tmp13_ = _tmp12_;
#line 128 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp13_)) {
#line 128 "../src/Permissions/Backend/App.vala"
					break;
#line 2868 "App.c"
				}
#line 129 "../src/Permissions/Backend/App.vala"
				_tmp14_ = _data5_->current_permissions;
#line 129 "../src/Permissions/Backend/App.vala"
				_tmp15_ = g_ptr_array_index (_tmp14_, (guint) i);
#line 129 "../src/Permissions/Backend/App.vala"
				_tmp16_ = g_strdup ((const gchar*) _tmp15_);
#line 129 "../src/Permissions/Backend/App.vala"
				permission = _tmp16_;
#line 130 "../src/Permissions/Backend/App.vala"
				_tmp17_ = permission;
#line 130 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (key, _tmp17_) == 0) {
#line 131 "../src/Permissions/Backend/App.vala"
					enabled = TRUE;
#line 132 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 132 "../src/Permissions/Backend/App.vala"
					break;
#line 2888 "App.c"
				}
#line 128 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 2892 "App.c"
			}
		}
	}
#line 136 "../src/Permissions/Backend/App.vala"
	_tmp18_ = permissions_backend_permission_settings_new (key, standard);
#line 136 "../src/Permissions/Backend/App.vala"
	permissions_backend_permission_settings_set_enabled (_tmp18_, enabled);
#line 136 "../src/Permissions/Backend/App.vala"
	s = _tmp18_;
#line 140 "../src/Permissions/Backend/App.vala"
	_tmp19_ = self->settings;
#line 140 "../src/Permissions/Backend/App.vala"
	_tmp20_ = s;
#line 140 "../src/Permissions/Backend/App.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 140 "../src/Permissions/Backend/App.vala"
	g_ptr_array_add (_tmp19_, _tmp21_);
#line 116 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (s);
#line 2912 "App.c"
}

static void
__permissions_backend_app___lambda4__gh_func (gconstpointer key,
                                              gconstpointer value,
                                              gpointer self)
{
#line 116 "../src/Permissions/Backend/App.vala"
	_permissions_backend_app___lambda4_ (self, (const gchar*) key);
#line 2922 "App.c"
}

static void
_permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 143 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_save_overrides ((PermissionsBackendApp*) self);
#line 2932 "App.c"
}

static GObject *
permissions_backend_app_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionsBackendApp * self;
	Block5Data* _data5_;
	FlatpakInstalledRef* _tmp0_;
	const gchar* _tmp1_;
	GDesktopAppInfo* appinfo = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GDesktopAppInfo* _tmp5_;
	GDesktopAppInfo* _tmp6_;
	GDesktopAppInfo* _tmp7_;
	GPtrArray* _tmp20_;
	GPtrArray* _tmp21_;
	GPtrArray* overrides = NULL;
	GPtrArray* _tmp35_;
	GPtrArray* _tmp46_;
	GHashTable* _tmp72_;
	GHashTable* _tmp73_;
	GError* _inner_error0_ = NULL;
#line 52 "../src/Permissions/Backend/App.vala"
	parent_class = G_OBJECT_CLASS (permissions_backend_app_parent_class);
#line 52 "../src/Permissions/Backend/App.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/Permissions/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 52 "../src/Permissions/Backend/App.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 52 "../src/Permissions/Backend/App.vala"
	_data5_->_ref_count_ = 1;
#line 52 "../src/Permissions/Backend/App.vala"
	_data5_->self = g_object_ref (self);
#line 53 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_installed_ref;
#line 53 "../src/Permissions/Backend/App.vala"
	_tmp1_ = flatpak_ref_get_name ((FlatpakRef*) _tmp0_);
#line 53 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_set_id (self, _tmp1_);
#line 55 "../src/Permissions/Backend/App.vala"
	_tmp2_ = self->priv->_id;
#line 55 "../src/Permissions/Backend/App.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".desktop", NULL);
#line 55 "../src/Permissions/Backend/App.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/Permissions/Backend/App.vala"
	_tmp5_ = g_desktop_app_info_new (_tmp4_);
#line 55 "../src/Permissions/Backend/App.vala"
	_tmp6_ = _tmp5_;
#line 55 "../src/Permissions/Backend/App.vala"
	_g_free0 (_tmp4_);
#line 55 "../src/Permissions/Backend/App.vala"
	appinfo = _tmp6_;
#line 56 "../src/Permissions/Backend/App.vala"
	_tmp7_ = appinfo;
#line 56 "../src/Permissions/Backend/App.vala"
	if (_tmp7_ != NULL) {
#line 2997 "App.c"
		GDesktopAppInfo* _tmp8_;
		const gchar* _tmp9_;
		GIcon* _tmp10_ = NULL;
		GDesktopAppInfo* _tmp11_;
		GIcon* _tmp12_;
		GIcon* _tmp13_;
		GDesktopAppInfo* _tmp15_;
		const gchar* _tmp16_;
#line 57 "../src/Permissions/Backend/App.vala"
		_tmp8_ = appinfo;
#line 57 "../src/Permissions/Backend/App.vala"
		_tmp9_ = g_app_info_get_name ((GAppInfo*) _tmp8_);
#line 57 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_name (self, _tmp9_);
#line 58 "../src/Permissions/Backend/App.vala"
		_tmp11_ = appinfo;
#line 58 "../src/Permissions/Backend/App.vala"
		_tmp12_ = g_app_info_get_icon ((GAppInfo*) _tmp11_);
#line 58 "../src/Permissions/Backend/App.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 58 "../src/Permissions/Backend/App.vala"
		_tmp10_ = _tmp13_;
#line 58 "../src/Permissions/Backend/App.vala"
		if (_tmp10_ == NULL) {
#line 3022 "App.c"
			GThemedIcon* _tmp14_;
#line 58 "../src/Permissions/Backend/App.vala"
			_tmp14_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 58 "../src/Permissions/Backend/App.vala"
			_g_object_unref0 (_tmp10_);
#line 58 "../src/Permissions/Backend/App.vala"
			_tmp10_ = (GIcon*) _tmp14_;
#line 3030 "App.c"
		}
#line 58 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_icon (self, _tmp10_);
#line 59 "../src/Permissions/Backend/App.vala"
		_tmp15_ = appinfo;
#line 59 "../src/Permissions/Backend/App.vala"
		_tmp16_ = g_app_info_get_description ((GAppInfo*) _tmp15_);
#line 59 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_description (self, _tmp16_);
#line 56 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (_tmp10_);
#line 3042 "App.c"
	} else {
		GThemedIcon* _tmp17_;
		GThemedIcon* _tmp18_;
		const gchar* _tmp19_;
#line 61 "../src/Permissions/Backend/App.vala"
		_tmp17_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 61 "../src/Permissions/Backend/App.vala"
		_tmp18_ = _tmp17_;
#line 61 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_icon (self, (GIcon*) _tmp18_);
#line 61 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (_tmp18_);
#line 62 "../src/Permissions/Backend/App.vala"
		_tmp19_ = self->priv->_id;
#line 62 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_name (self, _tmp19_);
#line 3059 "App.c"
	}
#line 65 "../src/Permissions/Backend/App.vala"
	_tmp20_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 65 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (self->settings);
#line 65 "../src/Permissions/Backend/App.vala"
	self->settings = _tmp20_;
#line 67 "../src/Permissions/Backend/App.vala"
	_tmp21_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 67 "../src/Permissions/Backend/App.vala"
	_data5_->permissions = _tmp21_;
#line 3071 "App.c"
	{
		GBytes* metadata = NULL;
		FlatpakInstalledRef* _tmp22_;
		GBytes* _tmp23_;
#line 69 "../src/Permissions/Backend/App.vala"
		_tmp22_ = self->priv->_installed_ref;
#line 69 "../src/Permissions/Backend/App.vala"
		_tmp23_ = flatpak_installed_ref_load_metadata (_tmp22_, NULL, &_inner_error0_);
#line 69 "../src/Permissions/Backend/App.vala"
		metadata = _tmp23_;
#line 69 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3084 "App.c"
			goto __catch0_g_error;
		}
		{
			GKeyFile* key_file = NULL;
			GKeyFile* _tmp24_;
			GKeyFile* _tmp25_;
			GBytes* _tmp26_;
			GKeyFile* _tmp27_;
			GPtrArray* _tmp28_;
#line 71 "../src/Permissions/Backend/App.vala"
			_tmp24_ = g_key_file_new ();
#line 71 "../src/Permissions/Backend/App.vala"
			key_file = _tmp24_;
#line 72 "../src/Permissions/Backend/App.vala"
			_tmp25_ = key_file;
#line 72 "../src/Permissions/Backend/App.vala"
			_tmp26_ = metadata;
#line 72 "../src/Permissions/Backend/App.vala"
			g_key_file_load_from_bytes (_tmp25_, _tmp26_, G_KEY_FILE_NONE, &_inner_error0_);
#line 72 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/Permissions/Backend/App.vala"
				_g_key_file_unref0 (key_file);
#line 72 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3110 "App.c"
					goto __catch1_g_key_file_error;
				}
#line 72 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3115 "App.c"
					goto __catch1_g_file_error;
				}
#line 72 "../src/Permissions/Backend/App.vala"
				_g_bytes_unref0 (metadata);
#line 72 "../src/Permissions/Backend/App.vala"
				_g_object_unref0 (appinfo);
#line 72 "../src/Permissions/Backend/App.vala"
				block5_data_unref (_data5_);
#line 72 "../src/Permissions/Backend/App.vala"
				_data5_ = NULL;
#line 72 "../src/Permissions/Backend/App.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/Permissions/Backend/App.vala"
				g_clear_error (&_inner_error0_);
#line 3130 "App.c"
			}
#line 74 "../src/Permissions/Backend/App.vala"
			_tmp27_ = key_file;
#line 74 "../src/Permissions/Backend/App.vala"
			_tmp28_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp27_);
#line 74 "../src/Permissions/Backend/App.vala"
			_g_ptr_array_unref0 (_data5_->permissions);
#line 74 "../src/Permissions/Backend/App.vala"
			_data5_->permissions = _tmp28_;
#line 70 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 3142 "App.c"
		}
		goto __finally1;
		__catch1_g_key_file_error:
		{
			GError* e = NULL;
			GError* _tmp29_;
			const gchar* _tmp30_;
#line 70 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 70 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 76 "../src/Permissions/Backend/App.vala"
			_tmp29_ = e;
#line 76 "../src/Permissions/Backend/App.vala"
			_tmp30_ = _tmp29_->message;
#line 76 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:76: Couldn't create permissions keyfile: %s", _tmp30_);
#line 70 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 3162 "App.c"
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp31_;
			const gchar* _tmp32_;
#line 70 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 70 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 78 "../src/Permissions/Backend/App.vala"
			_tmp31_ = e;
#line 78 "../src/Permissions/Backend/App.vala"
			_tmp32_ = _tmp31_->message;
#line 78 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:78: Couldn't load permissions file: %s", _tmp32_);
#line 70 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 3182 "App.c"
		}
		__finally1:
#line 70 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/Permissions/Backend/App.vala"
			_g_bytes_unref0 (metadata);
#line 3189 "App.c"
			goto __catch0_g_error;
		}
#line 68 "../src/Permissions/Backend/App.vala"
		_g_bytes_unref0 (metadata);
#line 3194 "App.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
#line 68 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 68 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 81 "../src/Permissions/Backend/App.vala"
		_tmp33_ = e;
#line 81 "../src/Permissions/Backend/App.vala"
		_tmp34_ = _tmp33_->message;
#line 81 "../src/Permissions/Backend/App.vala"
		g_critical ("App.vala:81: Couldn't load metadata: %s", _tmp34_);
#line 68 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3214 "App.c"
	}
	__finally0:
#line 68 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (appinfo);
#line 68 "../src/Permissions/Backend/App.vala"
		block5_data_unref (_data5_);
#line 68 "../src/Permissions/Backend/App.vala"
		_data5_ = NULL;
#line 68 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 3229 "App.c"
	}
#line 84 "../src/Permissions/Backend/App.vala"
	_tmp35_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 84 "../src/Permissions/Backend/App.vala"
	overrides = _tmp35_;
#line 3235 "App.c"
	{
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp36_;
		GKeyFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GKeyFile* _tmp40_;
		GPtrArray* _tmp41_;
#line 86 "../src/Permissions/Backend/App.vala"
		_tmp36_ = g_key_file_new ();
#line 86 "../src/Permissions/Backend/App.vala"
		key_file = _tmp36_;
#line 87 "../src/Permissions/Backend/App.vala"
		_tmp37_ = key_file;
#line 87 "../src/Permissions/Backend/App.vala"
		_tmp38_ = permissions_backend_app_get_overrides_path (self);
#line 87 "../src/Permissions/Backend/App.vala"
		_tmp39_ = _tmp38_;
#line 87 "../src/Permissions/Backend/App.vala"
		g_key_file_load_from_file (_tmp37_, _tmp39_, G_KEY_FILE_NONE, &_inner_error0_);
#line 87 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp39_);
#line 87 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 87 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3264 "App.c"
				goto __catch2_g_key_file_error;
			}
#line 87 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3269 "App.c"
				goto __catch2_g_file_error;
			}
#line 87 "../src/Permissions/Backend/App.vala"
			_g_ptr_array_unref0 (overrides);
#line 87 "../src/Permissions/Backend/App.vala"
			_g_object_unref0 (appinfo);
#line 87 "../src/Permissions/Backend/App.vala"
			block5_data_unref (_data5_);
#line 87 "../src/Permissions/Backend/App.vala"
			_data5_ = NULL;
#line 87 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 3284 "App.c"
		}
#line 89 "../src/Permissions/Backend/App.vala"
		_tmp40_ = key_file;
#line 89 "../src/Permissions/Backend/App.vala"
		_tmp41_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp40_);
#line 89 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (overrides);
#line 89 "../src/Permissions/Backend/App.vala"
		overrides = _tmp41_;
#line 85 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 3296 "App.c"
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
#line 85 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 85 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 91 "../src/Permissions/Backend/App.vala"
		_tmp42_ = e;
#line 91 "../src/Permissions/Backend/App.vala"
		_tmp43_ = _tmp42_->message;
#line 91 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:91: Couldn't create overrides keyfile: %s", _tmp43_);
#line 85 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3316 "App.c"
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp44_;
		const gchar* _tmp45_;
#line 85 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 85 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 93 "../src/Permissions/Backend/App.vala"
		_tmp44_ = e;
#line 93 "../src/Permissions/Backend/App.vala"
		_tmp45_ = _tmp44_->message;
#line 93 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:93: Couldn't load overrides file: %s", _tmp45_);
#line 85 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3336 "App.c"
	}
	__finally2:
#line 85 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (overrides);
#line 85 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (appinfo);
#line 85 "../src/Permissions/Backend/App.vala"
		block5_data_unref (_data5_);
#line 85 "../src/Permissions/Backend/App.vala"
		_data5_ = NULL;
#line 85 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 3353 "App.c"
	}
#line 96 "../src/Permissions/Backend/App.vala"
	_tmp46_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 96 "../src/Permissions/Backend/App.vala"
	_data5_->current_permissions = _tmp46_;
#line 3359 "App.c"
	{
		gint i = 0;
#line 98 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 3364 "App.c"
		{
			gboolean _tmp47_ = FALSE;
#line 98 "../src/Permissions/Backend/App.vala"
			_tmp47_ = TRUE;
#line 98 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 3371 "App.c"
				GPtrArray* _tmp49_;
				gint _tmp50_;
				gint _tmp51_;
				gchar* permission = NULL;
				GPtrArray* _tmp52_;
				gconstpointer _tmp53_;
				gchar* _tmp54_;
				GPtrArray* _tmp55_;
				const gchar* _tmp56_;
				GPtrArray* _tmp57_;
				const gchar* _tmp58_;
				gchar* _tmp59_;
#line 98 "../src/Permissions/Backend/App.vala"
				if (!_tmp47_) {
#line 3386 "App.c"
					gint _tmp48_;
#line 98 "../src/Permissions/Backend/App.vala"
					_tmp48_ = i;
#line 98 "../src/Permissions/Backend/App.vala"
					i = _tmp48_ + 1;
#line 3392 "App.c"
				}
#line 98 "../src/Permissions/Backend/App.vala"
				_tmp47_ = FALSE;
#line 98 "../src/Permissions/Backend/App.vala"
				_tmp49_ = _data5_->permissions;
#line 98 "../src/Permissions/Backend/App.vala"
				_tmp50_ = vala_g_ptr_array_get_length (_tmp49_);
#line 98 "../src/Permissions/Backend/App.vala"
				_tmp51_ = _tmp50_;
#line 98 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp51_)) {
#line 98 "../src/Permissions/Backend/App.vala"
					break;
#line 3406 "App.c"
				}
#line 99 "../src/Permissions/Backend/App.vala"
				_tmp52_ = _data5_->permissions;
#line 99 "../src/Permissions/Backend/App.vala"
				_tmp53_ = g_ptr_array_index (_tmp52_, (guint) i);
#line 99 "../src/Permissions/Backend/App.vala"
				_tmp54_ = g_strdup ((const gchar*) _tmp53_);
#line 99 "../src/Permissions/Backend/App.vala"
				permission = _tmp54_;
#line 100 "../src/Permissions/Backend/App.vala"
				_tmp55_ = overrides;
#line 100 "../src/Permissions/Backend/App.vala"
				_tmp56_ = permission;
#line 100 "../src/Permissions/Backend/App.vala"
				if (permissions_backend_app_is_permission_overridden (self, _tmp55_, _tmp56_)) {
#line 101 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 101 "../src/Permissions/Backend/App.vala"
					continue;
#line 3426 "App.c"
				}
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp57_ = _data5_->current_permissions;
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp58_ = permission;
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp59_ = g_strdup (_tmp58_);
#line 104 "../src/Permissions/Backend/App.vala"
				g_ptr_array_add (_tmp57_, _tmp59_);
#line 98 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 3438 "App.c"
			}
		}
	}
	{
		gint i = 0;
#line 107 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 3446 "App.c"
		{
			gboolean _tmp60_ = FALSE;
#line 107 "../src/Permissions/Backend/App.vala"
			_tmp60_ = TRUE;
#line 107 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 3453 "App.c"
				GPtrArray* _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
				gchar* permission = NULL;
				GPtrArray* _tmp65_;
				gconstpointer _tmp66_;
				gchar* _tmp67_;
				const gchar* _tmp68_;
				GPtrArray* _tmp69_;
				const gchar* _tmp70_;
				gchar* _tmp71_;
#line 107 "../src/Permissions/Backend/App.vala"
				if (!_tmp60_) {
#line 3467 "App.c"
					gint _tmp61_;
#line 107 "../src/Permissions/Backend/App.vala"
					_tmp61_ = i;
#line 107 "../src/Permissions/Backend/App.vala"
					i = _tmp61_ + 1;
#line 3473 "App.c"
				}
#line 107 "../src/Permissions/Backend/App.vala"
				_tmp60_ = FALSE;
#line 107 "../src/Permissions/Backend/App.vala"
				_tmp62_ = overrides;
#line 107 "../src/Permissions/Backend/App.vala"
				_tmp63_ = vala_g_ptr_array_get_length (_tmp62_);
#line 107 "../src/Permissions/Backend/App.vala"
				_tmp64_ = _tmp63_;
#line 107 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp64_)) {
#line 107 "../src/Permissions/Backend/App.vala"
					break;
#line 3487 "App.c"
				}
#line 108 "../src/Permissions/Backend/App.vala"
				_tmp65_ = overrides;
#line 108 "../src/Permissions/Backend/App.vala"
				_tmp66_ = g_ptr_array_index (_tmp65_, (guint) i);
#line 108 "../src/Permissions/Backend/App.vala"
				_tmp67_ = g_strdup ((const gchar*) _tmp66_);
#line 108 "../src/Permissions/Backend/App.vala"
				permission = _tmp67_;
#line 109 "../src/Permissions/Backend/App.vala"
				_tmp68_ = permission;
#line 109 "../src/Permissions/Backend/App.vala"
				if (string_contains (_tmp68_, "=!")) {
#line 110 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 110 "../src/Permissions/Backend/App.vala"
					continue;
#line 3505 "App.c"
				}
#line 113 "../src/Permissions/Backend/App.vala"
				_tmp69_ = _data5_->current_permissions;
#line 113 "../src/Permissions/Backend/App.vala"
				_tmp70_ = permission;
#line 113 "../src/Permissions/Backend/App.vala"
				_tmp71_ = g_strdup (_tmp70_);
#line 113 "../src/Permissions/Backend/App.vala"
				g_ptr_array_add (_tmp69_, _tmp71_);
#line 107 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 3517 "App.c"
			}
		}
	}
#line 116 "../src/Permissions/Backend/App.vala"
	_tmp72_ = permissions_backend_app_get_permission_names ();
#line 116 "../src/Permissions/Backend/App.vala"
	_tmp73_ = _tmp72_;
#line 116 "../src/Permissions/Backend/App.vala"
	g_hash_table_foreach (_tmp73_, __permissions_backend_app___lambda4__gh_func, _data5_);
#line 143 "../src/Permissions/Backend/App.vala"
	g_signal_connect_object ((GObject*) self, "notify::settings", (GCallback) _permissions_backend_app_save_overrides_g_object_notify, self, 0);
#line 145 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_save_overrides (self);
#line 52 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (overrides);
#line 52 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (appinfo);
#line 52 "../src/Permissions/Backend/App.vala"
	block5_data_unref (_data5_);
#line 52 "../src/Permissions/Backend/App.vala"
	_data5_ = NULL;
#line 52 "../src/Permissions/Backend/App.vala"
	return obj;
#line 3541 "App.c"
}

static void
permissions_backend_app_class_init (PermissionsBackendAppClass * klass,
                                    gpointer klass_data)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	GHashTable* _tmp7_;
	GHashTable* _tmp8_;
	GHashTable* _tmp9_;
	GHashTable* _tmp10_;
	GHashTable* _tmp11_;
	GHashTable* _tmp12_;
	GHashTable* _tmp13_;
	GHashTable* _tmp14_;
	GHashTable* _tmp15_;
	GHashTable* _tmp16_;
	GHashTable* _tmp17_;
	GHashTable* _tmp18_;
	GHashTable* _tmp19_;
#line 24 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Permissions/Backend/App.vala"
	g_type_class_adjust_private_offset (klass, &PermissionsBackendApp_private_offset);
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_permissions_backend_app_get_property;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_permissions_backend_app_set_property;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->constructor = permissions_backend_app_constructor;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->finalize = permissions_backend_app_finalize;
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY] = g_param_spec_object ("installed-ref", "installed-ref", "installed-ref", flatpak_installed_ref_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_ID_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_NAME_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_ICON_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Permissions/Backend/App.vala"
	_tmp0_ = g_str_hash;
#line 41 "../src/Permissions/Backend/App.vala"
	_tmp1_ = g_str_equal;
#line 41 "../src/Permissions/Backend/App.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, NULL);
#line 41 "../src/Permissions/Backend/App.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_set_permission_names (_tmp3_);
#line 41 "../src/Permissions/Backend/App.vala"
	_g_hash_table_unref0 (_tmp3_);
#line 42 "../src/Permissions/Backend/App.vala"
	_tmp4_ = permissions_backend_app_get_permission_names ();
#line 42 "../src/Permissions/Backend/App.vala"
	_tmp5_ = _tmp4_;
#line 42 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp5_, "filesystems=home", _ ("Home Folder"));
#line 43 "../src/Permissions/Backend/App.vala"
	_tmp6_ = permissions_backend_app_get_permission_names ();
#line 43 "../src/Permissions/Backend/App.vala"
	_tmp7_ = _tmp6_;
#line 43 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp7_, "filesystems=host", _ ("System Folders"));
#line 44 "../src/Permissions/Backend/App.vala"
	_tmp8_ = permissions_backend_app_get_permission_names ();
#line 44 "../src/Permissions/Backend/App.vala"
	_tmp9_ = _tmp8_;
#line 44 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp9_, "devices=all", _ ("Devices"));
#line 45 "../src/Permissions/Backend/App.vala"
	_tmp10_ = permissions_backend_app_get_permission_names ();
#line 45 "../src/Permissions/Backend/App.vala"
	_tmp11_ = _tmp10_;
#line 45 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp11_, "shared=network", _ ("Network"));
#line 46 "../src/Permissions/Backend/App.vala"
	_tmp12_ = permissions_backend_app_get_permission_names ();
#line 46 "../src/Permissions/Backend/App.vala"
	_tmp13_ = _tmp12_;
#line 46 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp13_, "features=bluetooth", _ ("Bluetooth"));
#line 47 "../src/Permissions/Backend/App.vala"
	_tmp14_ = permissions_backend_app_get_permission_names ();
#line 47 "../src/Permissions/Backend/App.vala"
	_tmp15_ = _tmp14_;
#line 47 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp15_, "sockets=cups", _ ("Printing"));
#line 48 "../src/Permissions/Backend/App.vala"
	_tmp16_ = permissions_backend_app_get_permission_names ();
#line 48 "../src/Permissions/Backend/App.vala"
	_tmp17_ = _tmp16_;
#line 48 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp17_, "sockets=ssh-auth", _ ("Secure Shell Agent"));
#line 49 "../src/Permissions/Backend/App.vala"
	_tmp18_ = permissions_backend_app_get_permission_names ();
#line 49 "../src/Permissions/Backend/App.vala"
	_tmp19_ = _tmp18_;
#line 49 "../src/Permissions/Backend/App.vala"
	g_hash_table_insert (_tmp19_, "devices=dri", _ ("GPU Acceleration"));
#line 3650 "App.c"
}

static void
permissions_backend_app_instance_init (PermissionsBackendApp * self,
                                       gpointer klass)
{
#line 24 "../src/Permissions/Backend/App.vala"
	self->priv = permissions_backend_app_get_instance_private (self);
#line 28 "../src/Permissions/Backend/App.vala"
	self->priv->_description = NULL;
#line 3661 "App.c"
}

static void
permissions_backend_app_finalize (GObject * obj)
{
	PermissionsBackendApp * self;
#line 24 "../src/Permissions/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 25 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (self->priv->_installed_ref);
#line 26 "../src/Permissions/Backend/App.vala"
	_g_free0 (self->priv->_id);
#line 27 "../src/Permissions/Backend/App.vala"
	_g_free0 (self->priv->_name);
#line 28 "../src/Permissions/Backend/App.vala"
	_g_free0 (self->priv->_description);
#line 29 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (self->priv->_icon);
#line 30 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (self->settings);
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (permissions_backend_app_parent_class)->finalize (obj);
#line 3684 "App.c"
}

static GType
permissions_backend_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PermissionsBackendAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permissions_backend_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionsBackendApp), 0, (GInstanceInitFunc) permissions_backend_app_instance_init, NULL };
	GType permissions_backend_app_type_id;
	permissions_backend_app_type_id = g_type_register_static (G_TYPE_OBJECT, "PermissionsBackendApp", &g_define_type_info, 0);
	PermissionsBackendApp_private_offset = g_type_add_instance_private (permissions_backend_app_type_id, sizeof (PermissionsBackendAppPrivate));
	return permissions_backend_app_type_id;
}

GType
permissions_backend_app_get_type (void)
{
	static volatile gsize permissions_backend_app_type_id__once = 0;
	if (g_once_init_enter (&permissions_backend_app_type_id__once)) {
		GType permissions_backend_app_type_id;
		permissions_backend_app_type_id = permissions_backend_app_get_type_once ();
		g_once_init_leave (&permissions_backend_app_type_id__once, permissions_backend_app_type_id);
	}
	return permissions_backend_app_type_id__once;
}

static void
_vala_permissions_backend_app_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 24 "../src/Permissions/Backend/App.vala"
	switch (property_id) {
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_object (value, permissions_backend_app_get_installed_ref (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_string (value, permissions_backend_app_get_id (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_string (value, permissions_backend_app_get_name (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_string (value, permissions_backend_app_get_description (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ICON_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_object (value, permissions_backend_app_get_icon (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3749 "App.c"
		default:
#line 24 "../src/Permissions/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3755 "App.c"
	}
}

static void
_vala_permissions_backend_app_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 24 "../src/Permissions/Backend/App.vala"
	switch (property_id) {
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_installed_ref (self, g_value_get_object (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_id (self, g_value_get_string (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_name (self, g_value_get_string (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_DESCRIPTION_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_description (self, g_value_get_string (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ICON_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_icon (self, g_value_get_object (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3799 "App.c"
		default:
#line 24 "../src/Permissions/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3805 "App.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

