/* AppSettingsView.c generated by valac 0.56.17, the Vala compiler
 * generated from AppSettingsView.vala, do not modify */

/*
* Copyright 2020-2024 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "applications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <switchboard.h>
#include <granite-7.h>

#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_TABLE "background"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_ID "background"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_TABLE "location"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_ID "location"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_TABLE "screenshot"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_ID "screenshot"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_TABLE "wallpaper"
#define PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_ID "wallpaper"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_0_PROPERTY,
	PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY,
	PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_NUM_PROPERTIES
};
static GParamSpec* permissions_widgets_app_settings_view_properties[PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _PermissionsWidgetsAppSettingsViewUpdatePermissionsData PermissionsWidgetsAppSettingsViewUpdatePermissionsData;

struct _PermissionsWidgetsAppSettingsViewPrivate {
	PermissionsBackendApp* _selected_app;
	gchar* location_timestamp;
	GtkListBox* sandbox_box;
	GtkListBox* permission_box;
	GtkButton* reset_button;
	PermissionsWidgetsPermissionSettingsWidget* background_row;
	PermissionsWidgetsPermissionSettingsWidget* location_row;
	PermissionsWidgetsPermissionSettingsWidget* screenshot_row;
	PermissionsWidgetsPermissionSettingsWidget* wallpaper_row;
};

struct _Block6Data {
	int _ref_count_;
	PermissionsWidgetsAppSettingsView* self;
	gboolean should_enable_reset;
	PermissionsPermissionStore* permission_store;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	PermissionsBackendPermissionSettings* settings;
};

struct _PermissionsWidgetsAppSettingsViewUpdatePermissionsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PermissionsWidgetsAppSettingsView* self;
	PermissionsPermissionStore* permission_store;
	PermissionsPermissionStore* _tmp0_;
	PermissionsPermissionStore* _tmp1_;
	PermissionsPermissionStore* _tmp2_;
	PermissionStoreDBus* _tmp3_;
	PermissionStoreDBus* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	gchar** background_permission;
	PermissionsPermissionStore* _tmp7_;
	PermissionsBackendApp* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gint _tmp11_;
	gchar** _tmp12_;
	gint background_permission_length1;
	gint _background_permission_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp18_;
	GtkWidget* _tmp19_;
	GtkWidget* _tmp20_;
	GtkListBox* _tmp21_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp22_;
	gchar** location_permission;
	PermissionsPermissionStore* _tmp23_;
	PermissionsBackendApp* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gint _tmp27_;
	gchar** _tmp28_;
	gint location_permission_length1;
	gint _location_permission_size_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	const gchar* _tmp30_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	const gchar* _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp37_;
	GtkWidget* _tmp38_;
	GtkWidget* _tmp39_;
	GtkListBox* _tmp40_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp41_;
	gchar** screenshot_permission;
	PermissionsPermissionStore* _tmp42_;
	PermissionsBackendApp* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	gint _tmp46_;
	gchar** _tmp47_;
	gint screenshot_permission_length1;
	gint _screenshot_permission_size_;
	gchar** _tmp48_;
	gint _tmp48__length1;
	const gchar* _tmp49_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp50_;
	gchar** _tmp51_;
	gint _tmp51__length1;
	const gchar* _tmp52_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp53_;
	GtkWidget* _tmp54_;
	GtkWidget* _tmp55_;
	GtkListBox* _tmp56_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp57_;
	gchar** wallpaper_permission;
	PermissionsPermissionStore* _tmp58_;
	PermissionsBackendApp* _tmp59_;
	const gchar* _tmp60_;
	const gchar* _tmp61_;
	gint _tmp62_;
	gchar** _tmp63_;
	gint wallpaper_permission_length1;
	gint _wallpaper_permission_size_;
	gchar** _tmp64_;
	gint _tmp64__length1;
	const gchar* _tmp65_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp66_;
	gchar** _tmp67_;
	gint _tmp67__length1;
	const gchar* _tmp68_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp69_;
	GtkWidget* _tmp70_;
	GtkWidget* _tmp71_;
	GtkListBox* _tmp72_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp73_;
	GtkListBox* _tmp74_;
	GtkListBox* _tmp75_;
	GtkListBoxRow* _tmp76_;
};

static gint PermissionsWidgetsAppSettingsView_private_offset;
static gpointer permissions_widgets_app_settings_view_parent_class = NULL;

static void permissions_widgets_app_settings_view_update_view (PermissionsWidgetsAppSettingsView* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda6_ (Block6Data* _data6_,
                 PermissionsBackendPermissionSettings* settings);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda7_ (Block7Data* _data7_);
static void permissions_widgets_app_settings_view_change_permission_settings (PermissionsWidgetsAppSettingsView* self,
                                                                       PermissionsBackendPermissionSettings* settings);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda13_ (Block6Data* _data6_);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda14_ (Block6Data* _data6_);
static void ___lambda14__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda15_ (Block6Data* _data6_);
static void ___lambda15__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda16_ (Block6Data* _data6_);
static void ___lambda16__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void permissions_widgets_app_settings_view_update_permissions (PermissionsWidgetsAppSettingsView* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void permissions_widgets_app_settings_view_update_permissions_finish (PermissionsWidgetsAppSettingsView* self,
                                                                      GAsyncResult* _res_);
static void _permissions_widgets_app_settings_view_update_permissions_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self);
static void _permissions_widgets_app_settings_view_update_permissions_permissions_permission_store_changed (PermissionsPermissionStore* _sender,
                                                                                                     gpointer self);
static void permissions_widgets_app_settings_view_update_permissions_data_free (gpointer _data);
static gboolean permissions_widgets_app_settings_view_update_permissions_co (PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_);
static void permissions_widgets_app_settings_view_update_permissions_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static GObject * permissions_widgets_app_settings_view_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
static void _permissions_widgets_app_settings_view_update_view_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void _permissions_widgets_app_settings_view___lambda17_ (PermissionsWidgetsAppSettingsView* self,
                                                         GtkListBoxRow* row);
static void __permissions_widgets_app_settings_view___lambda17__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                     GtkListBoxRow* row,
                                                                                     gpointer self);
static void _permissions_widgets_app_settings_view___lambda18_ (PermissionsWidgetsAppSettingsView* self,
                                                         GtkListBoxRow* row);
static void __permissions_widgets_app_settings_view___lambda18__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                     GtkListBoxRow* row,
                                                                                     gpointer self);
static void _permissions_widgets_app_settings_view___lambda19_ (PermissionsWidgetsAppSettingsView* self);
static void __permissions_widgets_app_settings_view___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void permissions_widgets_app_settings_view_finalize (GObject * obj);
static GType permissions_widgets_app_settings_view_get_type_once (void);
static void _vala_permissions_widgets_app_settings_view_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_permissions_widgets_app_settings_view_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
permissions_widgets_app_settings_view_get_instance_private (PermissionsWidgetsAppSettingsView* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionsWidgetsAppSettingsView_private_offset);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	return _data6_;
#line 296 "AppSettingsView.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 306 "AppSettingsView.c"
		PermissionsWidgetsAppSettingsView* self;
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
		self = _data6_->self;
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_object_unref0 (_data6_->permission_store);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_object_unref0 (self);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_slice_free (Block6Data, _data6_);
#line 316 "AppSettingsView.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	return self ? g_object_ref (self) : NULL;
#line 325 "AppSettingsView.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	return _data7_;
#line 335 "AppSettingsView.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 345 "AppSettingsView.c"
		PermissionsWidgetsAppSettingsView* self;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
		self = _data7_->_data6_->self;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_object_unref0 (_data7_->settings);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
		block6_data_unref (_data7_->_data6_);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data7_->_data6_ = NULL;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_slice_free (Block7Data, _data7_);
#line 357 "AppSettingsView.c"
	}
}

static void
__lambda7_ (Block7Data* _data7_)
{
	Block6Data* _data6_;
	PermissionsWidgetsAppSettingsView* self;
#line 158 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_ = _data7_->_data6_;
#line 158 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 159 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_change_permission_settings (self, _data7_->settings);
#line 372 "AppSettingsView.c"
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 158 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda7_ (self);
#line 382 "AppSettingsView.c"
}

static void
__lambda6_ (Block6Data* _data6_,
            PermissionsBackendPermissionSettings* settings)
{
	PermissionsWidgetsAppSettingsView* self;
	Block7Data* _data7_;
	PermissionsBackendPermissionSettings* _tmp0_;
	gchar* description = NULL;
	gchar* _tmp1_;
	gchar* icon_name = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label0 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label1 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label2 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label3 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label4 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label5 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label6 = 0;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	static GQuark _tmp6_label7 = 0;
#line 416 "AppSettingsView.c"
	PermissionsWidgetsPermissionSettingsWidget* override_row = NULL;
	GHashTable* _tmp24_;
	GHashTable* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gconstpointer _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp31_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	gboolean _tmp36_;
	GtkListBox* _tmp37_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp38_;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (settings != NULL);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data7_->_ref_count_ = 1;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data7_->_data6_ = block6_data_ref (_data6_);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (_data7_->settings);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data7_->settings = _tmp0_;
#line 113 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = g_strdup ("Unknown");
#line 113 "../src/Permissions/Widgets/AppSettingsView.vala"
	description = _tmp1_;
#line 114 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = g_strdup ("image-missing");
#line 114 "../src/Permissions/Widgets/AppSettingsView.vala"
	icon_name = _tmp2_;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = permissions_backend_permission_settings_get_context (_data7_->settings);
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = _tmp3_;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = _tmp4_;
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("filesystems=home")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 469 "AppSettingsView.c"
			default:
			{
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 118 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp8_ = g_strdup (_ ("Including all documents, downloads, music, pictures, videos, and any h" \
"idden folders."));
#line 118 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 118 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp8_;
#line 119 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp9_ = g_strdup ("user-home");
#line 119 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 119 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp9_;
#line 120 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 488 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("filesystems=host")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 494 "AppSettingsView.c"
			default:
			{
				gchar* _tmp10_;
				gchar* _tmp11_;
#line 122 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp10_ = g_strdup (_ ("Including everyone's Home folders, but not including system internals."));
#line 122 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 122 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp10_;
#line 123 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp11_ = g_strdup ("drive-harddisk");
#line 123 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 123 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp11_;
#line 124 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 513 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("devices=all")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 519 "AppSettingsView.c"
			default:
			{
				gchar* _tmp12_;
				gchar* _tmp13_;
#line 126 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp12_ = g_strdup (_ ("Manage all connected devices, such as webcams, microphones, and USB de" \
"vices."));
#line 126 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 126 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp12_;
#line 127 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp13_ = g_strdup ("camera-web");
#line 127 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 127 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp13_;
#line 128 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 538 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label3) ? _tmp6_label3 : (_tmp6_label3 = g_quark_from_static_string ("shared=network")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 544 "AppSettingsView.c"
			default:
			{
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 130 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp14_ = g_strdup (_ ("Connect to the Internet and local networks."));
#line 130 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 130 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp14_;
#line 131 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp15_ = g_strdup ("preferences-system-network");
#line 131 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 131 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp15_;
#line 132 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 563 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label4) ? _tmp6_label4 : (_tmp6_label4 = g_quark_from_static_string ("features=bluetooth")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 569 "AppSettingsView.c"
			default:
			{
				gchar* _tmp16_;
				gchar* _tmp17_;
#line 134 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp16_ = g_strdup (_ ("Manage Bluetooth devices including pairing, unpairing, and discovery."));
#line 134 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 134 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp16_;
#line 135 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp17_ = g_strdup ("bluetooth");
#line 135 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 135 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp17_;
#line 136 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 588 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label5) ? _tmp6_label5 : (_tmp6_label5 = g_quark_from_static_string ("sockets=cups")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 594 "AppSettingsView.c"
			default:
			{
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 138 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp18_ = g_strdup (_ ("Manage printers and see the print queue."));
#line 138 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 138 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp18_;
#line 139 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp19_ = g_strdup ("printer");
#line 139 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 139 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp19_;
#line 140 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 613 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label6) ? _tmp6_label6 : (_tmp6_label6 = g_quark_from_static_string ("sockets=ssh-auth")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 619 "AppSettingsView.c"
			default:
			{
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 142 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp20_ = g_strdup (_ ("Connect to other devices on the network via SSH."));
#line 142 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 142 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp20_;
#line 143 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp21_ = g_strdup ("utilities-terminal");
#line 143 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 143 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp21_;
#line 144 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 638 "AppSettingsView.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label7) ? _tmp6_label7 : (_tmp6_label7 = g_quark_from_static_string ("devices=dri")))) {
#line 116 "../src/Permissions/Widgets/AppSettingsView.vala"
		switch (0) {
#line 644 "AppSettingsView.c"
			default:
			{
				gchar* _tmp22_;
				gchar* _tmp23_;
#line 146 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp22_ = g_strdup (_ ("Accelerate graphical output."));
#line 146 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (description);
#line 146 "../src/Permissions/Widgets/AppSettingsView.vala"
				description = _tmp22_;
#line 147 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp23_ = g_strdup ("application-x-firmware");
#line 147 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_free0 (icon_name);
#line 147 "../src/Permissions/Widgets/AppSettingsView.vala"
				icon_name = _tmp23_;
#line 148 "../src/Permissions/Widgets/AppSettingsView.vala"
				break;
#line 663 "AppSettingsView.c"
			}
		}
	}
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp24_ = permissions_backend_app_get_permission_names ();
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp25_ = _tmp24_;
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp26_ = permissions_backend_permission_settings_get_context (_data7_->settings);
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp27_ = _tmp26_;
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp28_ = g_hash_table_lookup (_tmp25_, _tmp27_);
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp29_ = description;
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp30_ = icon_name;
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp31_ = permissions_widgets_permission_settings_widget_new ((const gchar*) _tmp28_, _tmp29_, _tmp30_);
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp31_);
#line 151 "../src/Permissions/Widgets/AppSettingsView.vala"
	override_row = _tmp31_;
#line 157 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp32_ = override_row;
#line 157 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_bind_property_with_closures ((GObject*) _data7_->settings, "enabled", (GObject*) _tmp32_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 158 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_data ((GObject*) _data7_->settings, "notify::enabled", (GCallback) ___lambda7__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 162 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp33_ = permissions_backend_permission_settings_get_enabled (_data7_->settings);
#line 162 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp34_ = _tmp33_;
#line 162 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp35_ = permissions_backend_permission_settings_get_standard (_data7_->settings);
#line 162 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp36_ = _tmp35_;
#line 162 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp34_ != _tmp36_) {
#line 163 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data6_->should_enable_reset = TRUE;
#line 705 "AppSettingsView.c"
	}
#line 166 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp37_ = self->priv->sandbox_box;
#line 166 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp38_ = override_row;
#line 166 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_list_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (override_row);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_free0 (icon_name);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_free0 (description);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	block7_data_unref (_data7_);
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data7_ = NULL;
#line 723 "AppSettingsView.c"
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda6_ (self, (PermissionsBackendPermissionSettings*) data);
#line 732 "AppSettingsView.c"
}

static void
__lambda13_ (Block6Data* _data6_)
{
	PermissionsWidgetsAppSettingsView* self;
	const gchar* _tmp0_ = NULL;
	PermissionsWidgetsPermissionSettingsWidget* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar** permissions = NULL;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint permissions_length1;
	gint _permissions_size_;
	PermissionsPermissionStore* _tmp6_;
	PermissionsBackendApp* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 177 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->background_row;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = permissions_widgets_permission_settings_widget_get_active (_tmp1_);
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = _tmp2_;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp3_) {
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "yes";
#line 764 "AppSettingsView.c"
	} else {
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "no";
#line 768 "AppSettingsView.c"
	}
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_[0] = _tmp4_;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = _tmp5_;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_length1 = 1;
#line 178 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_size_ = permissions_length1;
#line 179 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = _data6_->permission_store;
#line 179 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = self->priv->_selected_app;
#line 179 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = permissions_backend_app_get_id (_tmp7_);
#line 179 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = _tmp8_;
#line 179 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_set_permission (_tmp6_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_ID, _tmp9_, permissions, (gint) permissions_length1);
#line 177 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = (_vala_array_free (permissions, permissions_length1, (GDestroyNotify) g_free), NULL);
#line 794 "AppSettingsView.c"
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 177 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda13_ (self);
#line 804 "AppSettingsView.c"
}

static void
__lambda14_ (Block6Data* _data6_)
{
	PermissionsWidgetsAppSettingsView* self;
	const gchar* _tmp0_ = NULL;
	PermissionsWidgetsPermissionSettingsWidget* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar** permissions = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint permissions_length1;
	gint _permissions_size_;
	PermissionsPermissionStore* _tmp8_;
	PermissionsBackendApp* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 188 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->location_row;
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = permissions_widgets_permission_settings_widget_get_active (_tmp1_);
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = _tmp2_;
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp3_) {
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "EXACT";
#line 838 "AppSettingsView.c"
	} else {
#line 190 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "NONE";
#line 842 "AppSettingsView.c"
	}
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = self->priv->location_timestamp;
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_[0] = _tmp4_;
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_[1] = _tmp6_;
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = _tmp7_;
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_length1 = 2;
#line 189 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_size_ = permissions_length1;
#line 193 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = _data6_->permission_store;
#line 193 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = self->priv->_selected_app;
#line 193 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp10_ = permissions_backend_app_get_id (_tmp9_);
#line 193 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp11_ = _tmp10_;
#line 193 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_set_permission (_tmp8_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_ID, _tmp11_, permissions, (gint) permissions_length1);
#line 188 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = (_vala_array_free (permissions, permissions_length1, (GDestroyNotify) g_free), NULL);
#line 874 "AppSettingsView.c"
}

static void
___lambda14__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 188 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda14_ (self);
#line 884 "AppSettingsView.c"
}

static void
__lambda15_ (Block6Data* _data6_)
{
	PermissionsWidgetsAppSettingsView* self;
	const gchar* _tmp0_ = NULL;
	PermissionsWidgetsPermissionSettingsWidget* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar** permissions = NULL;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint permissions_length1;
	gint _permissions_size_;
	PermissionsPermissionStore* _tmp6_;
	PermissionsBackendApp* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 202 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->screenshot_row;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = permissions_widgets_permission_settings_widget_get_active (_tmp1_);
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = _tmp2_;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp3_) {
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "yes";
#line 916 "AppSettingsView.c"
	} else {
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "no";
#line 920 "AppSettingsView.c"
	}
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_[0] = _tmp4_;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = _tmp5_;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_length1 = 1;
#line 203 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_size_ = permissions_length1;
#line 204 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = _data6_->permission_store;
#line 204 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = self->priv->_selected_app;
#line 204 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = permissions_backend_app_get_id (_tmp7_);
#line 204 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = _tmp8_;
#line 204 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_set_permission (_tmp6_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_ID, _tmp9_, permissions, (gint) permissions_length1);
#line 202 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = (_vala_array_free (permissions, permissions_length1, (GDestroyNotify) g_free), NULL);
#line 946 "AppSettingsView.c"
}

static void
___lambda15__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 202 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda15_ (self);
#line 956 "AppSettingsView.c"
}

static void
__lambda16_ (Block6Data* _data6_)
{
	PermissionsWidgetsAppSettingsView* self;
	const gchar* _tmp0_ = NULL;
	PermissionsWidgetsPermissionSettingsWidget* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar** permissions = NULL;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint permissions_length1;
	gint _permissions_size_;
	PermissionsPermissionStore* _tmp6_;
	PermissionsBackendApp* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 213 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = _data6_->self;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->wallpaper_row;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = permissions_widgets_permission_settings_widget_get_active (_tmp1_);
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = _tmp2_;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp3_) {
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "yes";
#line 988 "AppSettingsView.c"
	} else {
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = "no";
#line 992 "AppSettingsView.c"
	}
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_[0] = _tmp4_;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = _tmp5_;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_length1 = 1;
#line 214 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_size_ = permissions_length1;
#line 215 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = _data6_->permission_store;
#line 215 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = self->priv->_selected_app;
#line 215 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = permissions_backend_app_get_id (_tmp7_);
#line 215 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = _tmp8_;
#line 215 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_set_permission (_tmp6_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_ID, _tmp9_, permissions, (gint) permissions_length1);
#line 213 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions = (_vala_array_free (permissions, permissions_length1, (GDestroyNotify) g_free), NULL);
#line 1018 "AppSettingsView.c"
}

static void
___lambda16__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 213 "../src/Permissions/Widgets/AppSettingsView.vala"
	__lambda16_ (self);
#line 1028 "AppSettingsView.c"
}

static void
_permissions_widgets_app_settings_view_update_permissions_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self)
{
#line 219 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_permissions ((PermissionsWidgetsAppSettingsView*) self, NULL, NULL);
#line 1038 "AppSettingsView.c"
}

static void
_permissions_widgets_app_settings_view_update_permissions_permissions_permission_store_changed (PermissionsPermissionStore* _sender,
                                                                                                gpointer self)
{
#line 220 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_permissions ((PermissionsWidgetsAppSettingsView*) self, NULL, NULL);
#line 1047 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_update_view (PermissionsWidgetsAppSettingsView* self)
{
	Block6Data* _data6_;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	PermissionsBackendApp* _tmp2_;
	PermissionsBackendApp* _tmp3_;
	GPtrArray* _tmp4_;
	PermissionsPermissionStore* _tmp5_;
	PermissionsPermissionStore* _tmp6_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp7_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp8_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp9_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp10_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp11_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp12_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp13_;
	PermissionsWidgetsPermissionSettingsWidget* _tmp14_;
	PermissionsPermissionStore* _tmp15_;
	PermissionsPermissionStore* _tmp16_;
	GtkButton* _tmp17_;
	PermissionsBackendApp* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	PermissionsBackendApp* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	PermissionsBackendApp* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	PermissionsBackendApp* _tmp29_;
	GIcon* _tmp30_;
	GIcon* _tmp31_;
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_->_ref_count_ = 1;
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_->self = g_object_ref (self);
#line 103 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = self->priv->permission_box;
#line 103 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_list_box_remove_all (_tmp0_);
#line 104 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->sandbox_box;
#line 104 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_list_box_remove_all (_tmp1_);
#line 106 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = self->priv->_selected_app;
#line 106 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp2_ == NULL) {
#line 107 "../src/Permissions/Widgets/AppSettingsView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 108 "../src/Permissions/Widgets/AppSettingsView.vala"
		block6_data_unref (_data6_);
#line 108 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data6_ = NULL;
#line 108 "../src/Permissions/Widgets/AppSettingsView.vala"
		return;
#line 1114 "AppSettingsView.c"
	}
#line 111 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_->should_enable_reset = FALSE;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = self->priv->_selected_app;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = _tmp3_->settings;
#line 112 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_ptr_array_foreach (_tmp4_, ___lambda6__gfunc, _data6_);
#line 169 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = permissions_permission_store_get_default ();
#line 169 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 169 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_->permission_store = _tmp6_;
#line 171 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = permissions_widgets_permission_settings_widget_new (_ ("Background Activity"), _ ("Perform tasks and use system resources while its window is closed."), "permissions-background");
#line 171 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp7_);
#line 171 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->background_row);
#line 171 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->background_row = _tmp7_;
#line 177 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = self->priv->background_row;
#line 177 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_data ((GObject*) _tmp8_, "notify::active", (GCallback) ___lambda13__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 182 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = permissions_widgets_permission_settings_widget_new (_ ("Location Services"), _ ("Determine the location of this device."), "preferences-system-privacy-location");
#line 182 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp9_);
#line 182 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->location_row);
#line 182 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->location_row = _tmp9_;
#line 188 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp10_ = self->priv->location_row;
#line 188 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_data ((GObject*) _tmp10_, "notify::active", (GCallback) ___lambda14__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 196 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp11_ = permissions_widgets_permission_settings_widget_new (_ ("Screenshot"), _ ("Take pictures of the display without asking first."), "accessories-screenshot-tool");
#line 196 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp11_);
#line 196 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->screenshot_row);
#line 196 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->screenshot_row = _tmp11_;
#line 202 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp12_ = self->priv->screenshot_row;
#line 202 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_data ((GObject*) _tmp12_, "notify::active", (GCallback) ___lambda15__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 207 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp13_ = permissions_widgets_permission_settings_widget_new (_ ("Wallpaper"), _ ("Set the wallpaper on the desktop and lock screen."), "preferences-desktop-wallpaper");
#line 207 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp13_);
#line 207 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->wallpaper_row);
#line 207 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->wallpaper_row = _tmp13_;
#line 213 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp14_ = self->priv->wallpaper_row;
#line 213 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_data ((GObject*) _tmp14_, "notify::active", (GCallback) ___lambda16__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 218 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_permissions (self, NULL, NULL);
#line 219 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp15_ = _data6_->permission_store;
#line 219 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::dbus", (GCallback) _permissions_widgets_app_settings_view_update_permissions_g_object_notify, self, 0);
#line 220 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp16_ = _data6_->permission_store;
#line 220 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object (_tmp16_, "changed", (GCallback) _permissions_widgets_app_settings_view_update_permissions_permissions_permission_store_changed, self, 0);
#line 222 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 223 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp17_ = self->priv->reset_button;
#line 223 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, _data6_->should_enable_reset);
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp18_ = self->priv->_selected_app;
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp19_ = permissions_backend_app_get_name (_tmp18_);
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp20_ = _tmp19_;
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp21_ = g_strdup_printf (_ ("%s permissions"), _tmp20_);
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp22_ = _tmp21_;
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_accessible_update_property ((GtkAccessible*) self, GTK_ACCESSIBLE_PROPERTY_LABEL, _tmp22_, -1, -1);
#line 225 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_free0 (_tmp22_);
#line 226 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp23_ = self->priv->_selected_app;
#line 226 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp24_ = permissions_backend_app_get_name (_tmp23_);
#line 226 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp25_ = _tmp24_;
#line 226 "../src/Permissions/Widgets/AppSettingsView.vala"
	switchboard_settings_page_set_title ((SwitchboardSettingsPage*) self, _tmp25_);
#line 227 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp26_ = self->priv->_selected_app;
#line 227 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp27_ = permissions_backend_app_get_description (_tmp26_);
#line 227 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp28_ = _tmp27_;
#line 227 "../src/Permissions/Widgets/AppSettingsView.vala"
	switchboard_settings_page_set_description ((SwitchboardSettingsPage*) self, _tmp28_);
#line 228 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp29_ = self->priv->_selected_app;
#line 228 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp30_ = permissions_backend_app_get_icon (_tmp29_);
#line 228 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp31_ = _tmp30_;
#line 228 "../src/Permissions/Widgets/AppSettingsView.vala"
	switchboard_settings_page_set_icon ((SwitchboardSettingsPage*) self, _tmp31_);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	block6_data_unref (_data6_);
#line 102 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data6_ = NULL;
#line 1236 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_update_permissions_data_free (gpointer _data)
{
	PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_;
	_data_ = _data;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_slice_free (PermissionsWidgetsAppSettingsViewUpdatePermissionsData, _data_);
#line 1248 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_update_permissions (PermissionsWidgetsAppSettingsView* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_;
	PermissionsWidgetsAppSettingsView* _tmp0_;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_ = g_slice_new0 (PermissionsWidgetsAppSettingsViewUpdatePermissionsData);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, permissions_widgets_app_settings_view_update_permissions_data_free);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_permissions_co (_data_);
#line 1272 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_update_permissions_finish (PermissionsWidgetsAppSettingsView* self,
                                                                 GAsyncResult* _res_)
{
	PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1282 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_update_permissions_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_ = _user_data_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_source_object_ = source_object;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_res_ = _res_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_permissions_co (_data_);
#line 1299 "AppSettingsView.c"
}

static gboolean
permissions_widgets_app_settings_view_update_permissions_co (PermissionsWidgetsAppSettingsViewUpdatePermissionsData* _data_)
{
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	switch (_data_->_state_) {
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		case 0:
#line 1309 "AppSettingsView.c"
		goto _state_0;
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		case 1:
#line 1313 "AppSettingsView.c"
		goto _state_1;
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		case 2:
#line 1317 "AppSettingsView.c"
		goto _state_2;
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		case 3:
#line 1321 "AppSettingsView.c"
		goto _state_3;
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		case 4:
#line 1325 "AppSettingsView.c"
		goto _state_4;
		default:
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_assert_not_reached ();
#line 1330 "AppSettingsView.c"
	}
	_state_0:
#line 232 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp0_ = permissions_permission_store_get_default ();
#line 232 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 232 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->permission_store = _data_->_tmp1_;
#line 233 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp2_ = _data_->permission_store;
#line 233 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp3_ = permissions_permission_store_get_dbus (_data_->_tmp2_);
#line 233 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 233 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_tmp4_ == NULL) {
#line 234 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp5_ = _data_->self->priv->permission_box;
#line 234 "../src/Permissions/Widgets/AppSettingsView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp5_, FALSE);
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_object_unref0 (_data_->permission_store);
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
		if (_data_->_state_ != 0) {
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1361 "AppSettingsView.c"
			}
		}
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_object_unref (_data_->_async_result);
#line 235 "../src/Permissions/Widgets/AppSettingsView.vala"
		return FALSE;
#line 1368 "AppSettingsView.c"
	}
#line 238 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp6_ = _data_->self->priv->permission_box;
#line 238 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp6_, TRUE);
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp7_ = _data_->permission_store;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp8_ = _data_->self->priv->_selected_app;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp9_ = permissions_backend_app_get_id (_data_->_tmp8_);
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp11_ = 0;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_state_ = 1;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_get_permission (_data_->_tmp7_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_BACKGROUND_ID, _data_->_tmp10_, permissions_widgets_app_settings_view_update_permissions_ready, _data_);
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	return FALSE;
#line 1390 "AppSettingsView.c"
	_state_1:
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp12_ = permissions_permission_store_get_permission_finish (_data_->_tmp7_, _data_->_res_, &_data_->_tmp11_);
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->background_permission = _data_->_tmp12_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->background_permission_length1 = _data_->_tmp11_;
#line 240 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_background_permission_size_ = _data_->background_permission_length1;
#line 241 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp13_ = _data_->background_permission;
#line 241 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp13__length1 = _data_->background_permission_length1;
#line 241 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp14_ = _data_->_tmp13_[0];
#line 241 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_tmp14_ != NULL) {
#line 242 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp15_ = _data_->self->priv->background_row;
#line 242 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp16_ = _data_->background_permission;
#line 242 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp16__length1 = _data_->background_permission_length1;
#line 242 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp17_ = _data_->_tmp16_[0];
#line 242 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active (_data_->_tmp15_, g_strcmp0 (_data_->_tmp17_, "yes") == 0);
#line 244 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp18_ = _data_->self->priv->background_row;
#line 244 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp19_ = gtk_widget_get_parent ((GtkWidget*) _data_->_tmp18_);
#line 244 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 244 "../src/Permissions/Widgets/AppSettingsView.vala"
		if (_data_->_tmp20_ == NULL) {
#line 245 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp21_ = _data_->self->priv->permission_box;
#line 245 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp22_ = _data_->self->priv->background_row;
#line 245 "../src/Permissions/Widgets/AppSettingsView.vala"
			gtk_list_box_append (_data_->_tmp21_, (GtkWidget*) _data_->_tmp22_);
#line 1432 "AppSettingsView.c"
		}
	}
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp23_ = _data_->permission_store;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp24_ = _data_->self->priv->_selected_app;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp25_ = permissions_backend_app_get_id (_data_->_tmp24_);
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp27_ = 0;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_state_ = 2;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_get_permission (_data_->_tmp23_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_LOCATION_ID, _data_->_tmp26_, permissions_widgets_app_settings_view_update_permissions_ready, _data_);
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	return FALSE;
#line 1451 "AppSettingsView.c"
	_state_2:
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp28_ = permissions_permission_store_get_permission_finish (_data_->_tmp23_, _data_->_res_, &_data_->_tmp27_);
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->location_permission = _data_->_tmp28_;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->location_permission_length1 = _data_->_tmp27_;
#line 249 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_location_permission_size_ = _data_->location_permission_length1;
#line 250 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp29_ = _data_->location_permission;
#line 250 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp29__length1 = _data_->location_permission_length1;
#line 250 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp30_ = _data_->_tmp29_[0];
#line 250 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_tmp30_ != NULL) {
#line 252 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp31_ = _data_->self->priv->location_row;
#line 252 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp32_ = _data_->location_permission;
#line 252 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp32__length1 = _data_->location_permission_length1;
#line 252 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp33_ = _data_->_tmp32_[0];
#line 252 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active (_data_->_tmp31_, g_strcmp0 (_data_->_tmp33_, "NONE") != 0);
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp34_ = _data_->location_permission;
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp34__length1 = _data_->location_permission_length1;
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp35_ = _data_->_tmp34_[1];
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp36_ = g_strdup (_data_->_tmp35_);
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_free0 (_data_->self->priv->location_timestamp);
#line 253 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->self->priv->location_timestamp = _data_->_tmp36_;
#line 255 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp37_ = _data_->self->priv->location_row;
#line 255 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp38_ = gtk_widget_get_parent ((GtkWidget*) _data_->_tmp37_);
#line 255 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 255 "../src/Permissions/Widgets/AppSettingsView.vala"
		if (_data_->_tmp39_ == NULL) {
#line 256 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp40_ = _data_->self->priv->permission_box;
#line 256 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp41_ = _data_->self->priv->location_row;
#line 256 "../src/Permissions/Widgets/AppSettingsView.vala"
			gtk_list_box_append (_data_->_tmp40_, (GtkWidget*) _data_->_tmp41_);
#line 1505 "AppSettingsView.c"
		}
	}
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp42_ = _data_->permission_store;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp43_ = _data_->self->priv->_selected_app;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp44_ = permissions_backend_app_get_id (_data_->_tmp43_);
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp45_ = _data_->_tmp44_;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp46_ = 0;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_state_ = 3;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_get_permission (_data_->_tmp42_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SCREENSHOT_ID, _data_->_tmp45_, permissions_widgets_app_settings_view_update_permissions_ready, _data_);
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	return FALSE;
#line 1524 "AppSettingsView.c"
	_state_3:
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp47_ = permissions_permission_store_get_permission_finish (_data_->_tmp42_, _data_->_res_, &_data_->_tmp46_);
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->screenshot_permission = _data_->_tmp47_;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->screenshot_permission_length1 = _data_->_tmp46_;
#line 260 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_screenshot_permission_size_ = _data_->screenshot_permission_length1;
#line 261 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp48_ = _data_->screenshot_permission;
#line 261 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp48__length1 = _data_->screenshot_permission_length1;
#line 261 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp49_ = _data_->_tmp48_[0];
#line 261 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_tmp49_ != NULL) {
#line 262 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp50_ = _data_->self->priv->screenshot_row;
#line 262 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp51_ = _data_->screenshot_permission;
#line 262 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp51__length1 = _data_->screenshot_permission_length1;
#line 262 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp52_ = _data_->_tmp51_[0];
#line 262 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active (_data_->_tmp50_, g_strcmp0 (_data_->_tmp52_, "yes") == 0);
#line 264 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp53_ = _data_->self->priv->screenshot_row;
#line 264 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp54_ = gtk_widget_get_parent ((GtkWidget*) _data_->_tmp53_);
#line 264 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp55_ = _data_->_tmp54_;
#line 264 "../src/Permissions/Widgets/AppSettingsView.vala"
		if (_data_->_tmp55_ == NULL) {
#line 265 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp56_ = _data_->self->priv->permission_box;
#line 265 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp57_ = _data_->self->priv->screenshot_row;
#line 265 "../src/Permissions/Widgets/AppSettingsView.vala"
			gtk_list_box_append (_data_->_tmp56_, (GtkWidget*) _data_->_tmp57_);
#line 1566 "AppSettingsView.c"
		}
	}
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp58_ = _data_->permission_store;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp59_ = _data_->self->priv->_selected_app;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp60_ = permissions_backend_app_get_id (_data_->_tmp59_);
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp61_ = _data_->_tmp60_;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp62_ = 0;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_state_ = 4;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_permission_store_get_permission (_data_->_tmp58_, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_TABLE, PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_WALLPAPER_ID, _data_->_tmp61_, permissions_widgets_app_settings_view_update_permissions_ready, _data_);
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	return FALSE;
#line 1585 "AppSettingsView.c"
	_state_4:
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp63_ = permissions_permission_store_get_permission_finish (_data_->_tmp58_, _data_->_res_, &_data_->_tmp62_);
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->wallpaper_permission = _data_->_tmp63_;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->wallpaper_permission_length1 = _data_->_tmp62_;
#line 269 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_wallpaper_permission_size_ = _data_->wallpaper_permission_length1;
#line 270 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp64_ = _data_->wallpaper_permission;
#line 270 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp64__length1 = _data_->wallpaper_permission_length1;
#line 270 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp65_ = _data_->_tmp64_[0];
#line 270 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_tmp65_ != NULL) {
#line 271 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp66_ = _data_->self->priv->wallpaper_row;
#line 271 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp67_ = _data_->wallpaper_permission;
#line 271 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp67__length1 = _data_->wallpaper_permission_length1;
#line 271 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp68_ = _data_->_tmp67_[0];
#line 271 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active (_data_->_tmp66_, g_strcmp0 (_data_->_tmp68_, "yes") == 0);
#line 273 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp69_ = _data_->self->priv->wallpaper_row;
#line 273 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp70_ = gtk_widget_get_parent ((GtkWidget*) _data_->_tmp69_);
#line 273 "../src/Permissions/Widgets/AppSettingsView.vala"
		_data_->_tmp71_ = _data_->_tmp70_;
#line 273 "../src/Permissions/Widgets/AppSettingsView.vala"
		if (_data_->_tmp71_ == NULL) {
#line 274 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp72_ = _data_->self->priv->permission_box;
#line 274 "../src/Permissions/Widgets/AppSettingsView.vala"
			_data_->_tmp73_ = _data_->self->priv->wallpaper_row;
#line 274 "../src/Permissions/Widgets/AppSettingsView.vala"
			gtk_list_box_append (_data_->_tmp72_, (GtkWidget*) _data_->_tmp73_);
#line 1627 "AppSettingsView.c"
		}
	}
#line 278 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp74_ = _data_->self->priv->permission_box;
#line 278 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp75_ = _data_->self->priv->permission_box;
#line 278 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->_tmp76_ = gtk_list_box_get_row_at_index (_data_->_tmp75_, 0);
#line 278 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_visible ((GtkWidget*) _data_->_tmp74_, _data_->_tmp76_ != NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->wallpaper_permission = (_vala_array_free (_data_->wallpaper_permission, _data_->wallpaper_permission_length1, (GDestroyNotify) g_free), NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->screenshot_permission = (_vala_array_free (_data_->screenshot_permission, _data_->screenshot_permission_length1, (GDestroyNotify) g_free), NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->location_permission = (_vala_array_free (_data_->location_permission, _data_->location_permission_length1, (GDestroyNotify) g_free), NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	_data_->background_permission = (_vala_array_free (_data_->background_permission, _data_->background_permission_length1, (GDestroyNotify) g_free), NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (_data_->permission_store);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_data_->_state_ != 0) {
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1656 "AppSettingsView.c"
		}
	}
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_unref (_data_->_async_result);
#line 231 "../src/Permissions/Widgets/AppSettingsView.vala"
	return FALSE;
#line 1663 "AppSettingsView.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 1676 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_change_permission_settings (PermissionsWidgetsAppSettingsView* self,
                                                                  PermissionsBackendPermissionSettings* settings)
{
	PermissionsBackendApp* _tmp0_;
	gboolean should_enable_reset = FALSE;
	PermissionsBackendApp* _tmp23_;
	GtkButton* _tmp24_;
#line 281 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (settings != NULL);
#line 282 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = self->priv->_selected_app;
#line 282 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp0_ == NULL) {
#line 283 "../src/Permissions/Widgets/AppSettingsView.vala"
		return;
#line 1697 "AppSettingsView.c"
	}
#line 286 "../src/Permissions/Widgets/AppSettingsView.vala"
	should_enable_reset = FALSE;
#line 1701 "AppSettingsView.c"
	{
		gint i = 0;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
		i = 0;
#line 1706 "AppSettingsView.c"
		{
			gboolean _tmp1_ = FALSE;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
			_tmp1_ = TRUE;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
			while (TRUE) {
#line 1713 "AppSettingsView.c"
				PermissionsBackendApp* _tmp3_;
				GPtrArray* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				PermissionsBackendPermissionSettings* s = NULL;
				PermissionsBackendApp* _tmp7_;
				GPtrArray* _tmp8_;
				gconstpointer _tmp9_;
				PermissionsBackendPermissionSettings* _tmp10_;
				PermissionsBackendPermissionSettings* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				if (!_tmp1_) {
#line 1730 "AppSettingsView.c"
					gint _tmp2_;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp2_ = i;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
					i = _tmp2_ + 1;
#line 1736 "AppSettingsView.c"
				}
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp1_ = FALSE;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp3_ = self->priv->_selected_app;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp4_ = _tmp3_->settings;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp5_ = vala_g_ptr_array_get_length (_tmp4_);
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp6_ = _tmp5_;
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				if (!(i < _tmp6_)) {
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
					break;
#line 1752 "AppSettingsView.c"
				}
#line 288 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp7_ = self->priv->_selected_app;
#line 288 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp8_ = _tmp7_->settings;
#line 288 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp9_ = g_ptr_array_index (_tmp8_, (guint) i);
#line 288 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp10_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp9_);
#line 288 "../src/Permissions/Widgets/AppSettingsView.vala"
				s = _tmp10_;
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp11_ = s;
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp12_ = permissions_backend_permission_settings_get_context (_tmp11_);
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp13_ = _tmp12_;
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp14_ = permissions_backend_permission_settings_get_context (settings);
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				_tmp15_ = _tmp14_;
#line 289 "../src/Permissions/Widgets/AppSettingsView.vala"
				if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 1776 "AppSettingsView.c"
					PermissionsBackendPermissionSettings* _tmp16_;
					gboolean _tmp17_;
					gboolean _tmp18_;
					gboolean _tmp19_;
					gboolean _tmp20_;
					gboolean _tmp21_;
					gboolean _tmp22_;
#line 290 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp16_ = s;
#line 290 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp17_ = permissions_backend_permission_settings_get_enabled (settings);
#line 290 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp18_ = _tmp17_;
#line 290 "../src/Permissions/Widgets/AppSettingsView.vala"
					permissions_backend_permission_settings_set_enabled (_tmp16_, _tmp18_);
#line 292 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp19_ = permissions_backend_permission_settings_get_enabled (settings);
#line 292 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp20_ = _tmp19_;
#line 292 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp21_ = permissions_backend_permission_settings_get_standard (settings);
#line 292 "../src/Permissions/Widgets/AppSettingsView.vala"
					_tmp22_ = _tmp21_;
#line 292 "../src/Permissions/Widgets/AppSettingsView.vala"
					if (_tmp20_ != _tmp22_) {
#line 293 "../src/Permissions/Widgets/AppSettingsView.vala"
						should_enable_reset = TRUE;
#line 1804 "AppSettingsView.c"
					}
#line 296 "../src/Permissions/Widgets/AppSettingsView.vala"
					_g_object_unref0 (s);
#line 296 "../src/Permissions/Widgets/AppSettingsView.vala"
					break;
#line 1810 "AppSettingsView.c"
				}
#line 287 "../src/Permissions/Widgets/AppSettingsView.vala"
				_g_object_unref0 (s);
#line 1814 "AppSettingsView.c"
			}
		}
	}
#line 300 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp23_ = self->priv->_selected_app;
#line 300 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_backend_app_save_overrides (_tmp23_);
#line 302 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp24_ = self->priv->reset_button;
#line 302 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, should_enable_reset);
#line 1826 "AppSettingsView.c"
}

PermissionsWidgetsAppSettingsView*
permissions_widgets_app_settings_view_construct (GType object_type)
{
	PermissionsWidgetsAppSettingsView * self = NULL;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = (PermissionsWidgetsAppSettingsView*) switchboard_settings_page_construct (object_type);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	return self;
#line 1837 "AppSettingsView.c"
}

PermissionsWidgetsAppSettingsView*
permissions_widgets_app_settings_view_new (void)
{
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	return permissions_widgets_app_settings_view_construct (PERMISSIONS_WIDGETS_TYPE_APP_SETTINGS_VIEW);
#line 1845 "AppSettingsView.c"
}

PermissionsBackendApp*
permissions_widgets_app_settings_view_get_selected_app (PermissionsWidgetsAppSettingsView* self)
{
	PermissionsBackendApp* result;
	PermissionsBackendApp* _tmp0_;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = self->priv->_selected_app;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	result = _tmp0_;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	return result;
#line 1861 "AppSettingsView.c"
}

void
permissions_widgets_app_settings_view_set_selected_app (PermissionsWidgetsAppSettingsView* self,
                                                        PermissionsBackendApp* value)
{
	PermissionsBackendApp* old_value;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	old_value = permissions_widgets_app_settings_view_get_selected_app (self);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (old_value != value) {
#line 1875 "AppSettingsView.c"
		PermissionsBackendApp* _tmp0_;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
		_g_object_unref0 (self->priv->_selected_app);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
		self->priv->_selected_app = _tmp0_;
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_widgets_app_settings_view_properties[PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY]);
#line 1885 "AppSettingsView.c"
	}
}

static void
_permissions_widgets_app_settings_view_update_view_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 45 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_view ((PermissionsWidgetsAppSettingsView*) self);
#line 1896 "AppSettingsView.c"
}

static void
_permissions_widgets_app_settings_view___lambda17_ (PermissionsWidgetsAppSettingsView* self,
                                                    GtkListBoxRow* row)
{
#line 82 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (row != NULL);
#line 83 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (PERMISSIONS_WIDGETS_IS_PERMISSION_SETTINGS_WIDGET (row)) {
#line 1907 "AppSettingsView.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 84 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = permissions_widgets_permission_settings_widget_get_active ((PermissionsWidgetsPermissionSettingsWidget*) row);
#line 84 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp1_ = _tmp0_;
#line 84 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active ((PermissionsWidgetsPermissionSettingsWidget*) row, !_tmp1_);
#line 1916 "AppSettingsView.c"
	}
}

static void
__permissions_widgets_app_settings_view___lambda17__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                GtkListBoxRow* row,
                                                                                gpointer self)
{
#line 82 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_widgets_app_settings_view___lambda17_ ((PermissionsWidgetsAppSettingsView*) self, row);
#line 1927 "AppSettingsView.c"
}

static void
_permissions_widgets_app_settings_view___lambda18_ (PermissionsWidgetsAppSettingsView* self,
                                                    GtkListBoxRow* row)
{
#line 88 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_return_if_fail (row != NULL);
#line 89 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (PERMISSIONS_WIDGETS_IS_PERMISSION_SETTINGS_WIDGET (row)) {
#line 1938 "AppSettingsView.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 90 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp0_ = permissions_widgets_permission_settings_widget_get_active ((PermissionsWidgetsPermissionSettingsWidget*) row);
#line 90 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp1_ = _tmp0_;
#line 90 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_permission_settings_widget_set_active ((PermissionsWidgetsPermissionSettingsWidget*) row, !_tmp1_);
#line 1947 "AppSettingsView.c"
	}
}

static void
__permissions_widgets_app_settings_view___lambda18__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                GtkListBoxRow* row,
                                                                                gpointer self)
{
#line 88 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_widgets_app_settings_view___lambda18_ ((PermissionsWidgetsAppSettingsView*) self, row);
#line 1958 "AppSettingsView.c"
}

static void
_permissions_widgets_app_settings_view___lambda19_ (PermissionsWidgetsAppSettingsView* self)
{
	PermissionsBackendApp* _tmp0_;
#line 95 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = self->priv->_selected_app;
#line 95 "../src/Permissions/Widgets/AppSettingsView.vala"
	if (_tmp0_ != NULL) {
#line 1969 "AppSettingsView.c"
		PermissionsBackendApp* _tmp1_;
#line 96 "../src/Permissions/Widgets/AppSettingsView.vala"
		_tmp1_ = self->priv->_selected_app;
#line 96 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_backend_app_reset_settings_to_standard (_tmp1_);
#line 97 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_app_settings_view_update_view (self);
#line 1977 "AppSettingsView.c"
	}
}

static void
__permissions_widgets_app_settings_view___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
#line 94 "../src/Permissions/Widgets/AppSettingsView.vala"
	_permissions_widgets_app_settings_view___lambda19_ ((PermissionsWidgetsAppSettingsView*) self);
#line 1987 "AppSettingsView.c"
}

static GObject *
permissions_widgets_app_settings_view_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionsWidgetsAppSettingsView * self;
	GtkListBox* _tmp0_ = NULL;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_ = NULL;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GraniteHeaderLabel* sandbox_header = NULL;
	GtkListBox* _tmp6_;
	GtkWidget* _tmp7_;
	gchar* _tmp8_;
	GraniteHeaderLabel* _tmp9_ = NULL;
	GtkButton* _tmp10_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkListBox* _tmp13_;
	GtkBox* _tmp14_;
	GraniteHeaderLabel* _tmp15_;
	GtkBox* _tmp16_;
	GtkListBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkButton* _tmp19_;
	GtkBox* _tmp20_;
	GtkListBox* _tmp21_;
	GtkListBox* _tmp22_;
	GtkButton* _tmp23_;
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	parent_class = G_OBJECT_CLASS (permissions_widgets_app_settings_view_parent_class);
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_WIDGETS_TYPE_APP_SETTINGS_VIEW, PermissionsWidgetsAppSettingsView);
#line 45 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object ((GObject*) self, "notify::selected-app", (GCallback) _permissions_widgets_app_settings_view_update_view_g_object_notify, self, 0);
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = (GtkListBox*) gtk_list_box_new ();
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_list_box_set_selection_mode (_tmp0_, GTK_SELECTION_NONE);
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp0_);
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->permission_box);
#line 47 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->permission_box = _tmp0_;
#line 51 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp1_ = self->priv->permission_box;
#line 51 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "boxed-list");
#line 52 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp2_ = self->priv->permission_box;
#line 52 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, GRANITE_STYLE_CLASS_RICH_LIST);
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_list_box_set_selection_mode (_tmp3_, GTK_SELECTION_NONE);
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp3_);
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->sandbox_box);
#line 54 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->sandbox_box = _tmp3_;
#line 58 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp4_ = self->priv->sandbox_box;
#line 58 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "boxed-list");
#line 59 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp5_ = self->priv->sandbox_box;
#line 59 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, GRANITE_STYLE_CLASS_RICH_LIST);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp6_ = self->priv->sandbox_box;
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp7_ = _g_object_ref0 ((GtkWidget*) _tmp6_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp8_ = g_strdup (_ ("Access to system features can be restricted to make apps more secure, " \
"but some apps may not function properly without it"));
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp9_ = granite_header_label_new (_ ("Advanced System Access"));
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_FILL);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	granite_header_label_set_mnemonic_widget (_tmp9_, _tmp7_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (_tmp7_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	granite_header_label_set_secondary_text (_tmp9_, _tmp8_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_free0 (_tmp8_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp9_);
#line 61 "../src/Permissions/Widgets/AppSettingsView.vala"
	sandbox_header = _tmp9_;
#line 67 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp10_ = (GtkButton*) gtk_button_new_with_label (_ ("Reset to Defaults"));
#line 67 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 67 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp10_);
#line 67 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->reset_button);
#line 67 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->reset_button = _tmp10_;
#line 71 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp11_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 71 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_ref_sink (_tmp11_);
#line 71 "../src/Permissions/Widgets/AppSettingsView.vala"
	box = _tmp11_;
#line 72 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp12_ = box;
#line 72 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp13_ = self->priv->permission_box;
#line 72 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 73 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp14_ = box;
#line 73 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp15_ = sandbox_header;
#line 73 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 74 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp16_ = box;
#line 74 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp17_ = self->priv->sandbox_box;
#line 74 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 75 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp18_ = box;
#line 75 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp19_ = self->priv->reset_button;
#line 75 "../src/Permissions/Widgets/AppSettingsView.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 77 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp20_ = box;
#line 77 "../src/Permissions/Widgets/AppSettingsView.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp20_);
#line 78 "../src/Permissions/Widgets/AppSettingsView.vala"
	switchboard_settings_page_set_show_end_title_buttons ((SwitchboardSettingsPage*) self, TRUE);
#line 80 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_update_view (self);
#line 82 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp21_ = self->priv->permission_box;
#line 82 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object (_tmp21_, "row-activated", (GCallback) __permissions_widgets_app_settings_view___lambda17__gtk_list_box_row_activated, self, 0);
#line 88 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp22_ = self->priv->sandbox_box;
#line 88 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object (_tmp22_, "row-activated", (GCallback) __permissions_widgets_app_settings_view___lambda18__gtk_list_box_row_activated, self, 0);
#line 94 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp23_ = self->priv->reset_button;
#line 94 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_signal_connect_object (_tmp23_, "clicked", (GCallback) __permissions_widgets_app_settings_view___lambda19__gtk_button_clicked, self, 0);
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (box);
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (sandbox_header);
#line 44 "../src/Permissions/Widgets/AppSettingsView.vala"
	return obj;
#line 2160 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_class_init (PermissionsWidgetsAppSettingsViewClass * klass,
                                                  gpointer klass_data)
{
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	permissions_widgets_app_settings_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_type_class_adjust_private_offset (klass, &PermissionsWidgetsAppSettingsView_private_offset);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_permissions_widgets_app_settings_view_get_property;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_permissions_widgets_app_settings_view_set_property;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	G_OBJECT_CLASS (klass)->constructor = permissions_widgets_app_settings_view_constructor;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	G_OBJECT_CLASS (klass)->finalize = permissions_widgets_app_settings_view_finalize;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY, permissions_widgets_app_settings_view_properties[PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY] = g_param_spec_object ("selected-app", "selected-app", "selected-app", PERMISSIONS_BACKEND_TYPE_APP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2181 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_instance_init (PermissionsWidgetsAppSettingsView * self,
                                                     gpointer klass)
{
	gchar* _tmp0_;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv = permissions_widgets_app_settings_view_get_instance_private (self);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->_selected_app = NULL;
#line 34 "../src/Permissions/Widgets/AppSettingsView.vala"
	_tmp0_ = g_strdup ("0");
#line 34 "../src/Permissions/Widgets/AppSettingsView.vala"
	self->priv->location_timestamp = _tmp0_;
#line 2197 "AppSettingsView.c"
}

static void
permissions_widgets_app_settings_view_finalize (GObject * obj)
{
	PermissionsWidgetsAppSettingsView * self;
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_WIDGETS_TYPE_APP_SETTINGS_VIEW, PermissionsWidgetsAppSettingsView);
#line 23 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->_selected_app);
#line 34 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_free0 (self->priv->location_timestamp);
#line 36 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->sandbox_box);
#line 37 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->permission_box);
#line 38 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->reset_button);
#line 39 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->background_row);
#line 40 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->location_row);
#line 41 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->screenshot_row);
#line 42 "../src/Permissions/Widgets/AppSettingsView.vala"
	_g_object_unref0 (self->priv->wallpaper_row);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	G_OBJECT_CLASS (permissions_widgets_app_settings_view_parent_class)->finalize (obj);
#line 2226 "AppSettingsView.c"
}

static GType
permissions_widgets_app_settings_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PermissionsWidgetsAppSettingsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permissions_widgets_app_settings_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionsWidgetsAppSettingsView), 0, (GInstanceInitFunc) permissions_widgets_app_settings_view_instance_init, NULL };
	GType permissions_widgets_app_settings_view_type_id;
	permissions_widgets_app_settings_view_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "PermissionsWidgetsAppSettingsView", &g_define_type_info, 0);
	PermissionsWidgetsAppSettingsView_private_offset = g_type_add_instance_private (permissions_widgets_app_settings_view_type_id, sizeof (PermissionsWidgetsAppSettingsViewPrivate));
	return permissions_widgets_app_settings_view_type_id;
}

GType
permissions_widgets_app_settings_view_get_type (void)
{
	static volatile gsize permissions_widgets_app_settings_view_type_id__once = 0;
	if (g_once_init_enter (&permissions_widgets_app_settings_view_type_id__once)) {
		GType permissions_widgets_app_settings_view_type_id;
		permissions_widgets_app_settings_view_type_id = permissions_widgets_app_settings_view_get_type_once ();
		g_once_init_leave (&permissions_widgets_app_settings_view_type_id__once, permissions_widgets_app_settings_view_type_id);
	}
	return permissions_widgets_app_settings_view_type_id__once;
}

static void
_vala_permissions_widgets_app_settings_view_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	PermissionsWidgetsAppSettingsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_WIDGETS_TYPE_APP_SETTINGS_VIEW, PermissionsWidgetsAppSettingsView);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	switch (property_id) {
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		case PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY:
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		g_value_set_object (value, permissions_widgets_app_settings_view_get_selected_app (self));
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		break;
#line 2267 "AppSettingsView.c"
		default:
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		break;
#line 2273 "AppSettingsView.c"
	}
}

static void
_vala_permissions_widgets_app_settings_view_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	PermissionsWidgetsAppSettingsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_WIDGETS_TYPE_APP_SETTINGS_VIEW, PermissionsWidgetsAppSettingsView);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
	switch (property_id) {
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		case PERMISSIONS_WIDGETS_APP_SETTINGS_VIEW_SELECTED_APP_PROPERTY:
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		permissions_widgets_app_settings_view_set_selected_app (self, g_value_get_object (value));
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		break;
#line 2293 "AppSettingsView.c"
		default:
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Permissions/Widgets/AppSettingsView.vala"
		break;
#line 2299 "AppSettingsView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

